#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <commctrl.h>
#include <richedit.h>
#include "AkelEdit.h"
#include "AkelDLL.h"
#include "ConvFunc.h"
#include "StackFunc.h"
#include "Resources\Resource.h"


//Include conversion functions
#define xatoiA
#define xatoiW
#include "ConvFunc.h"

//Include stack functions
#define StackGetElement
#define StackInsertAfter
#define StackInsertBefore
#define StackInsertIndex
#define StackDelete
#define StackClear
#define StackSize
#include "StackFunc.h"

//Defines
#define STRID_SETUP       1
#define STRID_AUTOLOAD    2
#define STRID_BIGICONS    3
#define STRID_FLATBUTTONS 4
#define STRID_OK          5
#define STRID_CANCEL      6

#define AKDLL_REFRESH     (WM_USER + 1)
#define AKDLL_SETUP       (WM_USER + 2)

#define OF_TOOLBARTEXT    0x1
#define OF_WINDOWRECT     0x2

#define ACT_COMMAND       1
#define ACT_CALL          2
#define ACT_EXEC          3
#define ACT_FONT          4
#define ACT_RECODE        5
#define ACT_INSERT        6

#define PARAM_CHAR        1
#define PARAM_INT         2

#define MAX_TOOLBARTEXT_SIZE  64000

#define FS_NONE            0
#define FS_FONTNORMAL      1
#define FS_FONTITALIC      2
#define FS_FONTBOLD        3
#define FS_FONTBOLDITALIC  4

#define IMENU_EDIT     0x00000001
#define IMENU_CHECKS   0x00000004

#define TOOLBARBACKGROUNDA   "ToolbarBG"
#define TOOLBARBACKGROUNDW  L"ToolbarBG"

//DIALOGRESIZE
#define DRS_SIZE  0x1 //Resize control
#define DRS_MOVE  0x2 //Move control
#define DRS_X     0x4 //X value
#define DRS_Y     0x8 //Y value

#define TXT_DEFAULT_PART1W \
L"# New document\r\
\"\" Command(4101) Icon(0)\r\
\r\
# New instance\r\
# \"\" Command(4102) Icon(1)\r\
\r\
# Open\r\
\"\" Command(4103) Icon(2)\r\
\r\
# Reload\r\
# \"\" Command(4104) Icon(3)\r\
\r\
# Save\r\
\"\" Command(4105) Icon(4)\r\
\r\
# Save as\r\
# \"\" Command(4106) Icon(5)\r\
\r\
SEPARATOR\r\
\r\
# Print\r\
\"\" Command(4108) Icon(6)\r\
\r\
# Print preview\r\
\"\" Command(4114) Icon(21)\r\
\r\
SEPARATOR\r\
\r\
# Cut\r\
\"\" Command(4153) Icon(7)\r\
\r\
# Copy\r\
\"\" Command(4154) Icon(8)\r\
\r\
# Paste\r\
\"\" Command(4155) Icon(9)\r\
\r\
SEPARATOR\r\
\r\
# Undo\r\
\"\" Command(4151) Icon(10)\r\
\r\
# Redo\r\
\"\" Command(4152) Icon(11)\r\
\r\
SEPARATOR\r\
\r\
# Find\r\
\"\" Command(4158) Icon(12)\r\
\r\
# Replace\r\
\"\" Command(4161) Icon(13)\r\
\r\
SEPARATOR\r\
\r\
# Insert char\r\
# \"\" Command(4163) Icon(14)\r\
\r\
# Word wrap\r\
\"\" Command(4209) Icon(16)\r\
\r\
# Split all\r\
#-\"\" Command(4212) Icon(22)\r\
\r\
# Split vertical\r\
#-\"\" Command(4213) Icon(23)\r\
\r\
# Split horizontal\r\
#-\"\" Command(4214) Icon(24)\r\
\r\
# On top\r\
\"\" Command(4210) Icon(15)\r\
\r\
# Execute\r\
# \"\" Command(4251) Icon(17)\r\
\r\
# Read-only\r\
\"\" Command(4261) Icon(20)\r\
\r\
SEPARATOR\r\
\r\
# Plugins\r\
\"\" Command(4259) Icon(18)\r\
\r\
# Settings\r\
\"\" Command(4260) Icon(19)"

#define TXT_DEFAULT_PART2W \
L"\r\
\r\
# SEPARATOR\r\
\r\
# \"LineBoard plugin\" +Call(\"LineBoard::Main\") Icon(\"%a\\AkelFiles\\Plugs\\LineBoard.dll\", 0)\r\
\r\
# \"CodeFold plugin\" +Call(\"CodeFold::Main\") Icon(\"%a\\AkelFiles\\Plugs\\CodeFold.dll\", 0)\r\
\r\
# \"Explorer plugin\" +Call(\"Explorer::Main\") Icon(\"%a\\AkelFiles\\Plugs\\Explorer.dll\", 0)\r\
\r\
# \"SpecialChar plugin\" +Call(\"SpecialChar::Main\") Icon(\"%a\\AkelFiles\\Plugs\\SpecialChar.dll\", 0)\r\
\r\
# \"Run Notepad\" Exec(\"notepad.exe\") Icon(\"notepad.exe\")"

#ifndef TBN_DROPDOWN
  #define TBN_DROPDOWN (TBN_FIRST - 10)
#endif
#ifndef TBSTYLE_DROPDOWN
  #define TBSTYLE_DROPDOWN 0x0008
#endif
#ifndef TBSTYLE_FLAT
  #define TBSTYLE_FLAT 0x0800
#endif
#ifndef TB_SETSTYLE
  #define TB_SETSTYLE (WM_USER + 56)
#endif
#ifndef TB_GETSTYLE
  #define TB_GETSTYLE (WM_USER + 57)
#endif
#ifndef TB_GETRECT
  #define TB_GETRECT (WM_USER + 51)
#endif
#ifndef TB_HITTEST
  #define TB_HITTEST (WM_USER + 69)
#endif
#ifndef TB_SETIMAGELIST
  #define TB_SETIMAGELIST (WM_USER + 48)
#endif
#ifndef TB_SETEXTENDEDSTYLE
  #define TB_SETEXTENDEDSTYLE (WM_USER + 84)
#endif
#ifndef TB_GETEXTENDEDSTYLE
  #define TB_GETEXTENDEDSTYLE (WM_USER + 85)
#endif
#ifndef TBSTYLE_EX_DRAWDDARROWS
  #define TBSTYLE_EX_DRAWDDARROWS 0x00000001
#endif
#ifndef _INC_COMMCTRL
  typedef struct tagNMMOUSE {
    NMHDR hdr;
    DWORD_PTR dwItemSpec;
    DWORD_PTR dwItemData;
    POINT pt;
    LPARAM dwHitInfo;
  } NMMOUSE, *LPNMMOUSE;
#endif

typedef struct _TOOLBARDATA {
  HSTACK hButtonsStack;
  HIMAGELIST hImageList;
} TOOLBARDATA;

typedef struct _TOOLBARITEMA {
  struct _TOOLBARITEMA *next;
  struct _TOOLBARITEMA *prev;
  TBBUTTON tbb;
  char szButtonItem[MAX_PATH];
  BOOL bUpdateItem;
  BOOL bSetOnStart;
  DWORD dwAction;
  HSTACK hParamStack;
} TOOLBARITEMA;

typedef struct _TOOLBARITEMW {
  struct _TOOLBARITEMW *next;
  struct _TOOLBARITEMW *prev;
  TBBUTTON tbb;
  wchar_t wszButtonItem[MAX_PATH];
  BOOL bUpdateItem;
  BOOL bSetOnStart;
  DWORD dwAction;
  HSTACK hParamStack;
} TOOLBARITEMW;

typedef struct _PARAMETER {
  struct _PARAMETER *next;
  struct _PARAMETER *prev;
  DWORD dwType;
  LPARAM lParam;
  unsigned char *pExpanded;
} PARAMETER;

typedef struct _PLUGINCALL {
  unsigned char *lpStruct;
  BOOL bOnStart;
  BOOL bSetOnStart;
} PLUGINCALL;

typedef struct {
  HWND *lpWnd;   //Control window
  DWORD dwType;  //See DRS_* defines
} DIALOGRESIZE;

//Functions prototypes
BOOL CALLBACK SetupDlgProcA(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
BOOL CALLBACK SetupDlgProcW(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK NewEditDlgProcA(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK NewEditDlgProcW(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK NewMainProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
void CALLBACK NewMainProcRet(CWPRETSTRUCT *cwprs);
LRESULT CALLBACK ToolbarBGProcA(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK ToolbarBGProcW(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK NewToolbarProcA(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK NewToolbarProcW(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
void CreateToolbarA();
void CreateToolbarW();
void CreateToolbarDataA(TOOLBARDATA *hToolbarData, char *pText);
void CreateToolbarDataW(TOOLBARDATA *hToolbarData, wchar_t *wpText);
void FreeToolbarDataA(TOOLBARDATA *hToolbarData);
void FreeToolbarDataW(TOOLBARDATA *hToolbarData);
void SetToolbarButtonsA(TOOLBARDATA *hToolbarData);
void SetToolbarButtonsW(TOOLBARDATA *hToolbarData);
void ClearToolbarButtons();
void UpdateToolbarA(HSTACK *hStack);
void UpdateToolbarW(HSTACK *hStack);
void CALLBACK CallPluginA(void *lpParameter);
void CALLBACK CallPluginW(void *lpParameter);
void CallToolbarA(HSTACK *hStack, int nItem);
void CallToolbarW(HSTACK *hStack, int nItem);
void DestroyToolbarA();
void DestroyToolbarW();
TOOLBARITEMA* StackInsertButtonA(HSTACK *hStack);
TOOLBARITEMW* StackInsertButtonW(HSTACK *hStack);
TOOLBARITEMA* StackGetButtonA(HSTACK *hStack, int nItemID);
TOOLBARITEMW* StackGetButtonW(HSTACK *hStack, int nItemID);
void StackFreeButtonA(HSTACK *hStack);
void StackFreeButtonW(HSTACK *hStack);
void GetActionParametersA(HSTACK *hParamStack, char *pText, char **ppText);
void GetActionParametersW(HSTACK *hParamStack, wchar_t *wpText, wchar_t **wppText);
void SetParametersExpCharA(HSTACK *hParamStack, char *pFile, char *pExeDir, char *pToolbarID, char *pItemID);
void SetParametersExpCharW(HSTACK *hParamStack, wchar_t *wpFile, wchar_t *wpExeDir, wchar_t *wpToolbarID, wchar_t *wpItemID);
int CreateParametersStruct(HSTACK *hParamStack, unsigned char **lppStruct);
int GetParameterInt(HSTACK *hParamStack, int nIndex);
unsigned char* GetParameterChar(HSTACK *hParamStack, int nIndex);
unsigned char* GetParameterExpChar(HSTACK *hParamStack, int nIndex);
void FreeActionParameters(HSTACK *hParamStack);
void GetIconParametersA(char *pText, char *szIconFile, int nMaxIconFile, int *nIconIndex, char **ppText);
void GetIconParametersW(wchar_t *wpText, wchar_t *wszIconFile, int nMaxIconFile, int *nIconIndex, wchar_t **wppText);
int TranslateFileStringA(char *pString, char *szBuffer, int nBufferSize);
int TranslateFileStringW(wchar_t *wpString, wchar_t *wszBuffer, int nBufferSize);
int NextStringA(char *pText, char *szStr, int nStrLen, char **ppText, int *nMinus);
int NextStringW(wchar_t *wpText, wchar_t *wszStr, int nStrLen, wchar_t **wppText, int *nMinus);
int GetActionNameA(char *pText, char *szStr, int nStrLen, char **ppText);
int GetActionNameW(wchar_t *wpText, wchar_t *wszStr, int nStrLen, wchar_t **wppText);
int GetFileDirA(char *pFile, char *szFileDir, int nFileDirLen);
int GetFileDirW(wchar_t *wpFile, wchar_t *wszFileDir, int nFileDirLen);
void ShowStandartEditMenu(HWND hWnd, HMENU hMenu, BOOL bMouse);
BOOL GetWindowPos(HWND hWnd, HWND hWndOwner, RECT *rc);
BOOL DialogResizeMessages(DIALOGRESIZE *drs, RECT *rcInit, RECT *rcCurrent, HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
void ReadOptionsA();
void ReadOptionsW();
void SaveOptionsA(DWORD dwFlags);
void SaveOptionsW(DWORD dwFlags);
char* GetLangStringA(LANGID wLangID, int nStringID);
wchar_t* GetLangStringW(LANGID wLangID, int nStringID);
void InitCommon(PLUGINDATA *pd);
void InitMain();
void UninitMain();

//GetProcAddress
UINT (WINAPI *ExtractIconExAPtr)(char *, int, HICON *, HICON *, UINT);
UINT (WINAPI *ExtractIconExWPtr)(wchar_t *, int, HICON *, HICON *, UINT);

//Global variables
char szPluginName[MAX_PATH];
wchar_t wszPluginName[MAX_PATH];
HINSTANCE hInstanceEXE;
HINSTANCE hInstanceDLL;
HWND hMainWnd;
HWND hMdiClient;
BOOL bOldWindows;
BOOL bMDI;
BOOL bAkelEdit;
HMENU hMainMenu;
HMENU hMenuRecentFiles;
HMENU hPopupEdit;
HICON hMainIcon;
LANGID wLangSystem;
BOOL bInitCommon=FALSE;
BOOL bInitMain=FALSE;
char szExeDir[MAX_PATH];
wchar_t wszExeDir[MAX_PATH];
char *szToolBarText=NULL;
wchar_t *wszToolBarText=NULL;
TOOLBARDATA hToolbarStack;
HWND hToolbarBG=NULL;
HWND hToolbar=NULL;
HMENU hMenuCustomize=NULL;
BOOL bBigIcons=FALSE;
BOOL bFlatButtons=TRUE;
int nToolbarHeight=0;
RECT rcMainInitDialog={0};
RECT rcMainCurrentDialog={0};
BOOL bMainDialogRectSave=FALSE;
WNDPROC OldToolbarProc=NULL;
WNDPROC OldEditDlgProc=NULL;
WNDPROCDATA *NewMainProcData=NULL;
WNDPROCRETDATA *NewMainProcRetData=NULL;
WNDPROCRETDATA *NewFrameProcRetData=NULL;


//Identification
extern "C" void __declspec(dllexport) DllAkelPadID(PLUGINVERSION *pv)
{
  pv->dwAkelDllVersion=AKELDLL;
  pv->dwExeMinVersion3x=MAKE_IDENTIFIER(3, 7, 4, 0);
  pv->dwExeMinVersion4x=MAKE_IDENTIFIER(4, 4, 0, 0);
  pv->pPluginName="ToolBar";
}

//Plugin extern function
extern "C" void __declspec(dllexport) Main(PLUGINDATA *pd)
{
  if (pd->lpbAutoLoad)
  {
    *pd->lpbAutoLoad=TRUE;
    return;
  }

  if (!bInitCommon) InitCommon(pd);

  //Is plugin already loaded?
  if (bInitMain)
  {
    UninitMain();

    SendMessage(hMainWnd, AKD_RESIZE, 0, 0);
  }
  else
  {
    InitMain();

    if (!pd->bOnStart)
    {
      if (bOldWindows)
        CreateToolbarA();
      else
        CreateToolbarW();
      SendMessage(hMainWnd, AKD_RESIZE, 0, 0);
    }

    //Stay in memory, and show as active
    pd->nUnload=UD_NONUNLOAD_ACTIVE;
  }
}

BOOL CALLBACK SetupDlgProcA(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  static HWND hWndToolBarText;
  static HWND hWndBigIconsCheck;
  static HWND hWndFlatButtonsCheck;
  static HWND hWndOK;
  static HWND hWndCancel;
  static DIALOGRESIZE drs[]={{&hWndToolBarText,      DRS_SIZE|DRS_X|DRS_Y},
                             {&hWndBigIconsCheck,    DRS_MOVE|DRS_Y},
                             {&hWndFlatButtonsCheck, DRS_MOVE|DRS_Y},
                             {&hWndOK,               DRS_MOVE|DRS_X|DRS_Y},
                             {&hWndCancel,           DRS_MOVE|DRS_X|DRS_Y},
                             {0, 0}};

  if (uMsg == WM_INITDIALOG)
  {
    SendMessage(hDlg, WM_SETICON, (WPARAM)ICON_BIG, (LPARAM)hMainIcon);
    hWndToolBarText=GetDlgItem(hDlg, IDC_TOOLBARTEXT);
    hWndBigIconsCheck=GetDlgItem(hDlg, IDC_BIGICONS);
    hWndFlatButtonsCheck=GetDlgItem(hDlg, IDC_FLATBUTTONS);
    hWndOK=GetDlgItem(hDlg, IDOK);
    hWndCancel=GetDlgItem(hDlg, IDCANCEL);

    SetDlgItemTextA(hDlg, IDC_BIGICONS, GetLangStringA(wLangSystem, STRID_BIGICONS));
    SetDlgItemTextA(hDlg, IDC_FLATBUTTONS, GetLangStringA(wLangSystem, STRID_FLATBUTTONS));
    SetDlgItemTextA(hDlg, IDOK, GetLangStringA(wLangSystem, STRID_OK));
    SetDlgItemTextA(hDlg, IDCANCEL, GetLangStringA(wLangSystem, STRID_CANCEL));

    SendMessage(hWndToolBarText, EM_SETTEXTMODE, TM_PLAINTEXT|TM_MULTILEVELUNDO|TM_MULTICODEPAGE, 0);
    SendMessage(hWndToolBarText, EM_EXLIMITTEXT, 0, MAX_TOOLBARTEXT_SIZE);
    SetWindowTextA(hWndToolBarText, szToolBarText);

    if (bBigIcons)
      SendMessage(hWndBigIconsCheck, BM_SETCHECK, BST_CHECKED, 0);
    if (bFlatButtons)
      SendMessage(hWndFlatButtonsCheck, BM_SETCHECK, BST_CHECKED, 0);

    OldEditDlgProc=(WNDPROC)GetWindowLongA(hWndToolBarText, GWL_WNDPROC);
    SetWindowLongA(hWndToolBarText, GWL_WNDPROC, (LONG)NewEditDlgProcA);
  }
  else if (uMsg == WM_COMMAND)
  {
    if (LOWORD(wParam) == IDOK)
    {
      DWORD dwStyle;
      BOOL bUpdate=FALSE;
      BOOL bResize=FALSE;

      if (SendMessage(hWndBigIconsCheck, BM_GETCHECK, 0, 0) != bBigIcons)
      {
        bBigIcons=!bBigIcons;
        bUpdate=TRUE;
        bResize=TRUE;
      }
      if (SendMessage(hWndFlatButtonsCheck, BM_GETCHECK, 0, 0) != bFlatButtons)
      {
        bFlatButtons=!bFlatButtons;
        dwStyle=SendMessage(hToolbar, TB_GETSTYLE, 0, 0);

        if (bFlatButtons)
          SendMessage(hToolbar, TB_SETSTYLE, 0, dwStyle | TBSTYLE_FLAT);
        else
          SendMessage(hToolbar, TB_SETSTYLE, 0, dwStyle & ~TBSTYLE_FLAT);

        InvalidateRect(hToolbar, NULL, TRUE);
      }
      if (SendMessage(hWndToolBarText, EM_GETMODIFY, 0, 0))
      {
        GETTEXTRANGE gtr;
        int nTextLen;

        gtr.cpMin=0;
        gtr.cpMax=-1;

        if (nTextLen=SendMessage(hMainWnd, AKD_GETTEXTRANGE, (WPARAM)hWndToolBarText, (LPARAM)&gtr))
        {
          if (szToolBarText) GlobalFree((HGLOBAL)szToolBarText);

          if (szToolBarText=(char *)GlobalAlloc(GPTR, nTextLen + 1))
          {
            lstrcpyA(szToolBarText, (char *)gtr.pText);
            bUpdate=TRUE;
          }
          SendMessage(hMainWnd, AKD_FREETEXT, 0, (LPARAM)gtr.pText);
        }
      }
      if (bUpdate)
      {
        FreeToolbarDataA(&hToolbarStack);
        CreateToolbarDataA(&hToolbarStack, szToolBarText);
        ClearToolbarButtons();
        SetToolbarButtonsA(&hToolbarStack);
        UpdateToolbarA(&hToolbarStack.hButtonsStack);
        if (bResize) SendMessage(hMainWnd, AKD_RESIZE, 0, 0);
      }

      SaveOptionsA(OF_TOOLBARTEXT);

      EndDialog(hDlg, 0);
      return TRUE;
    }
    else if (LOWORD(wParam) == IDCANCEL)
    {
      EndDialog(hDlg, 0);
      return TRUE;
    }
  }
  else if (uMsg == WM_CLOSE)
  {
    PostMessage(hDlg, WM_COMMAND, IDCANCEL, 0);
    return TRUE;
  }

  if (DialogResizeMessages(&drs[0], &rcMainInitDialog, &rcMainCurrentDialog, hDlg, uMsg, wParam, lParam))
    bMainDialogRectSave=TRUE;

  return FALSE;
}

BOOL CALLBACK SetupDlgProcW(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  static HWND hWndToolBarText;
  static HWND hWndBigIconsCheck;
  static HWND hWndFlatButtonsCheck;
  static HWND hWndOK;
  static HWND hWndCancel;
  static DIALOGRESIZE drs[]={{&hWndToolBarText,      DRS_SIZE|DRS_X|DRS_Y},
                             {&hWndBigIconsCheck,    DRS_MOVE|DRS_Y},
                             {&hWndFlatButtonsCheck, DRS_MOVE|DRS_Y},
                             {&hWndOK,               DRS_MOVE|DRS_X|DRS_Y},
                             {&hWndCancel,           DRS_MOVE|DRS_X|DRS_Y},
                             {0, 0}};

  if (uMsg == WM_INITDIALOG)
  {
    SendMessage(hDlg, WM_SETICON, (WPARAM)ICON_BIG, (LPARAM)hMainIcon);
    hWndToolBarText=GetDlgItem(hDlg, IDC_TOOLBARTEXT);
    hWndBigIconsCheck=GetDlgItem(hDlg, IDC_BIGICONS);
    hWndFlatButtonsCheck=GetDlgItem(hDlg, IDC_FLATBUTTONS);
    hWndOK=GetDlgItem(hDlg, IDOK);
    hWndCancel=GetDlgItem(hDlg, IDCANCEL);

    SetDlgItemTextW(hDlg, IDC_BIGICONS, GetLangStringW(wLangSystem, STRID_BIGICONS));
    SetDlgItemTextW(hDlg, IDC_FLATBUTTONS, GetLangStringW(wLangSystem, STRID_FLATBUTTONS));
    SetDlgItemTextW(hDlg, IDOK, GetLangStringW(wLangSystem, STRID_OK));
    SetDlgItemTextW(hDlg, IDCANCEL, GetLangStringW(wLangSystem, STRID_CANCEL));

    SendMessage(hWndToolBarText, EM_SETTEXTMODE, TM_PLAINTEXT|TM_MULTILEVELUNDO|TM_MULTICODEPAGE, 0);
    SendMessage(hWndToolBarText, EM_EXLIMITTEXT, 0, MAX_TOOLBARTEXT_SIZE);
    SetWindowTextW(hWndToolBarText, wszToolBarText);

    if (bBigIcons)
      SendMessage(hWndBigIconsCheck, BM_SETCHECK, BST_CHECKED, 0);
    if (bFlatButtons)
      SendMessage(hWndFlatButtonsCheck, BM_SETCHECK, BST_CHECKED, 0);

    OldEditDlgProc=(WNDPROC)GetWindowLongW(hWndToolBarText, GWL_WNDPROC);
    SetWindowLongW(hWndToolBarText, GWL_WNDPROC, (LONG)NewEditDlgProcW);
  }
  else if (uMsg == WM_COMMAND)
  {
    if (LOWORD(wParam) == IDOK)
    {
      DWORD dwStyle;
      BOOL bUpdate=FALSE;
      BOOL bResize=FALSE;

      if (SendMessage(hWndBigIconsCheck, BM_GETCHECK, 0, 0) != bBigIcons)
      {
        bBigIcons=!bBigIcons;
        bUpdate=TRUE;
        bResize=TRUE;
      }
      if (SendMessage(hWndFlatButtonsCheck, BM_GETCHECK, 0, 0) != bFlatButtons)
      {
        bFlatButtons=!bFlatButtons;
        dwStyle=SendMessage(hToolbar, TB_GETSTYLE, 0, 0);

        if (bFlatButtons)
          SendMessage(hToolbar, TB_SETSTYLE, 0, dwStyle | TBSTYLE_FLAT);
        else
          SendMessage(hToolbar, TB_SETSTYLE, 0, dwStyle & ~TBSTYLE_FLAT);

        InvalidateRect(hToolbar, NULL, TRUE);
      }
      if (SendMessage(hWndToolBarText, EM_GETMODIFY, 0, 0))
      {
        GETTEXTRANGE gtr;
        int nTextLen;

        gtr.cpMin=0;
        gtr.cpMax=-1;

        if (nTextLen=SendMessage(hMainWnd, AKD_GETTEXTRANGE, (WPARAM)hWndToolBarText, (LPARAM)&gtr))
        {
          if (wszToolBarText) GlobalFree((HGLOBAL)wszToolBarText);

          if (wszToolBarText=(wchar_t *)GlobalAlloc(GPTR, nTextLen * sizeof(wchar_t) + 2))
          {
            lstrcpyW(wszToolBarText, (wchar_t *)gtr.pText);
            bUpdate=TRUE;
          }
          SendMessage(hMainWnd, AKD_FREETEXT, 0, (LPARAM)gtr.pText);
        }
      }
      if (bUpdate)
      {
        FreeToolbarDataW(&hToolbarStack);
        CreateToolbarDataW(&hToolbarStack, wszToolBarText);
        ClearToolbarButtons();
        SetToolbarButtonsW(&hToolbarStack);
        UpdateToolbarW(&hToolbarStack.hButtonsStack);
        if (bResize) SendMessage(hMainWnd, AKD_RESIZE, 0, 0);
      }

      SaveOptionsW(OF_TOOLBARTEXT);

      EndDialog(hDlg, 0);
      return TRUE;
    }
    else if (LOWORD(wParam) == IDCANCEL)
    {
      EndDialog(hDlg, 0);
      return TRUE;
    }
  }
  else if (uMsg == WM_CLOSE)
  {
    PostMessage(hDlg, WM_COMMAND, IDCANCEL, 0);
    return TRUE;
  }

  if (DialogResizeMessages(&drs[0], &rcMainInitDialog, &rcMainCurrentDialog, hDlg, uMsg, wParam, lParam))
    bMainDialogRectSave=TRUE;

  return FALSE;
}

LRESULT CALLBACK NewEditDlgProcA(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  LRESULT lResult;

  if (uMsg == WM_GETDLGCODE)
  {
    lResult=CallWindowProcA(OldEditDlgProc, hWnd, uMsg, wParam, lParam);

    if (lResult & DLGC_HASSETSEL)
    {
      lResult&=~DLGC_HASSETSEL;
    }
    return lResult;
  }
  else if (uMsg == WM_CONTEXTMENU)
  {
    ShowStandartEditMenu((HWND)wParam, hPopupEdit, !(lParam == -1));
  }
  return CallWindowProcA(OldEditDlgProc, hWnd, uMsg, wParam, lParam);
}

LRESULT CALLBACK NewEditDlgProcW(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  LRESULT lResult;

  if (uMsg == WM_GETDLGCODE)
  {
    lResult=CallWindowProcW(OldEditDlgProc, hWnd, uMsg, wParam, lParam);

    if (lResult & DLGC_HASSETSEL)
    {
      lResult&=~DLGC_HASSETSEL;
    }
    return lResult;
  }
  else if (uMsg == WM_CONTEXTMENU)
  {
    ShowStandartEditMenu((HWND)wParam, hPopupEdit, !(lParam == -1));
  }
  return CallWindowProcW(OldEditDlgProc, hWnd, uMsg, wParam, lParam);
}

LRESULT CALLBACK NewMainProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  if (uMsg == AKDN_MAIN_ONSTART_PRESHOW)
  {
    if (bOldWindows)
      CreateToolbarA();
    else
      CreateToolbarW();
  }
  else if (uMsg == AKDN_SIZE)
  {
    NSIZE *ns=(NSIZE *)lParam;

    if (hToolbarBG && hToolbar)
    {
      MoveWindow(hToolbarBG, ns->rcCurrent.left, ns->rcCurrent.top, ns->rcCurrent.right, nToolbarHeight, TRUE);
      MoveWindow(hToolbar, 0, 0, ns->rcCurrent.right, nToolbarHeight, TRUE);
      ns->rcCurrent.top+=nToolbarHeight;
      ns->rcCurrent.bottom-=nToolbarHeight;
    }
  }

  //Call next procedure
  return NewMainProcData->NextProc(hWnd, uMsg, wParam, lParam);
}

void CALLBACK NewMainProcRet(CWPRETSTRUCT *cwprs)
{
  if (cwprs->message == AKDN_DLLCALL ||
      cwprs->message == AKDN_DLLUNLOAD ||
      cwprs->message == AKDN_FRAME_NOWINDOWS ||
      cwprs->message == AKDN_FRAME_ACTIVATE)
  {
    PostMessage(hToolbarBG, AKDLL_REFRESH, 0, 0);
  }
  else if (cwprs->message == WM_COMMAND)
  {
    if (cwprs->hwnd == hMainWnd)
    {
      PostMessage(hToolbarBG, AKDLL_REFRESH, 0, 0);
    }
  }
  else if (cwprs->message == WM_NOTIFY)
  {
    if (cwprs->wParam == ID_EDIT)
    {
      if (bAkelEdit)
      {
        if (((NMHDR *)cwprs->lParam)->code == AEN_MODIFY)
        {
          PostMessage(hToolbarBG, AKDLL_REFRESH, 0, 0);
        }
      }
      if (((NMHDR *)cwprs->lParam)->code == EN_SELCHANGE)
      {
        PostMessage(hToolbarBG, AKDLL_REFRESH, 0, 0);
      }
    }

    if (!bAkelEdit)
    {
      if (cwprs->wParam == ID_STATUS)
      {
        if ((int)((NMHDR *)cwprs->lParam)->code == NM_DBLCLK)
        {
          if (((NMMOUSE *)cwprs->lParam)->dwItemSpec == 3)
          {
            PostMessage(hToolbarBG, AKDLL_REFRESH, 0, 0);
          }
        }
      }
    }
  }

  //Call next procedure
  if (cwprs->hwnd == hMainWnd)
  {
    if (NewMainProcRetData->NextProc)
      NewMainProcRetData->NextProc(cwprs);
  }
  else
  {
    if (NewFrameProcRetData->NextProc)
      NewFrameProcRetData->NextProc(cwprs);
  }
}

LRESULT CALLBACK ToolbarBGProcA(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  if (uMsg == AKDLL_REFRESH)
  {
    if (hToolbar) UpdateToolbarA(&hToolbarStack.hButtonsStack);
  }
  else if (uMsg == AKDLL_SETUP)
  {
    DialogBoxA(hInstanceDLL, MAKEINTRESOURCEA(IDD_SETUPA), hMainWnd, (DLGPROC)SetupDlgProcA);
  }
  else if (uMsg == WM_CONTEXTMENU)
  {
    POINT pt;
    int nCmd;

    if (lParam == -1)
    {
      pt.x=0;
      pt.y=0;
    }
    else
    {
      GetCursorPos(&pt);
    }
    nCmd=TrackPopupMenu(hMenuCustomize, TPM_RETURNCMD|TPM_NONOTIFY|TPM_LEFTBUTTON|TPM_RIGHTBUTTON, pt.x, pt.y, 0, hToolbarBG, NULL);

    if (nCmd == IDM_SETUP)
      PostMessage(hToolbarBG, AKDLL_SETUP, 0, 0);
  }
  else if (uMsg == WM_NOTIFY)
  {
    if (((NMHDR *)lParam)->code == TTN_GETDISPINFOA)
    {
      TOOLBARITEMA *lpElement;

      if (lpElement=StackGetButtonA(&hToolbarStack.hButtonsStack, ((NMHDR *)lParam)->idFrom))
      {
        memcpy(((NMTTDISPINFOA *)lParam)->szText, lpElement->szButtonItem, 80);
      }
    }
    else if (((NMHDR *)lParam)->code == TBN_DROPDOWN)
    {
      RECT rc;

      SendMessage(hToolbar, TB_GETRECT, ((NMTOOLBARA *)lParam)->iItem, (LPARAM)&rc);
      ClientToScreen(hToolbar, (LPPOINT)&rc.left);
      ClientToScreen(hToolbar, (LPPOINT)&rc.right);
      TrackPopupMenu(hMenuRecentFiles, TPM_LEFTBUTTON, rc.left, rc.bottom, 0, hMainWnd, NULL);
    }
  }
  else if (uMsg == WM_COMMAND)
  {
    if ((HWND)lParam == hToolbar)
    {
      CallToolbarA(&hToolbarStack.hButtonsStack, LOWORD(wParam));
      return TRUE;
    }
  }
  return DefWindowProcA(hWnd, uMsg, wParam, lParam);
}

LRESULT CALLBACK ToolbarBGProcW(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  if (uMsg == AKDLL_REFRESH)
  {
    if (hToolbar) UpdateToolbarW(&hToolbarStack.hButtonsStack);
  }
  else if (uMsg == AKDLL_SETUP)
  {
    DialogBoxW(hInstanceDLL, MAKEINTRESOURCEW(IDD_SETUPW), hMainWnd, (DLGPROC)SetupDlgProcW);
  }
  else if (uMsg == WM_CONTEXTMENU)
  {
    POINT pt;
    int nCmd;

    if (lParam == -1)
    {
      pt.x=0;
      pt.y=0;
    }
    else
    {
      GetCursorPos(&pt);
    }
    nCmd=TrackPopupMenu(hMenuCustomize, TPM_RETURNCMD|TPM_NONOTIFY|TPM_LEFTBUTTON|TPM_RIGHTBUTTON, pt.x, pt.y, 0, hToolbarBG, NULL);

    if (nCmd == IDM_SETUP)
      PostMessage(hToolbarBG, AKDLL_SETUP, 0, 0);
  }
  else if (uMsg == WM_NOTIFY)
  {
    if (((NMHDR *)lParam)->code == TTN_GETDISPINFOW)
    {
      TOOLBARITEMW *lpElement;

      if (lpElement=StackGetButtonW(&hToolbarStack.hButtonsStack, ((NMHDR *)lParam)->idFrom))
      {
        memcpy(((NMTTDISPINFOW *)lParam)->szText, lpElement->wszButtonItem, 80);
      }
    }
    else if (((NMHDR *)lParam)->code == TBN_DROPDOWN)
    {
      RECT rc;

      SendMessage(hToolbar, TB_GETRECT, ((NMTOOLBARW *)lParam)->iItem, (LPARAM)&rc);
      ClientToScreen(hToolbar, (LPPOINT)&rc.left);
      ClientToScreen(hToolbar, (LPPOINT)&rc.right);
      TrackPopupMenu(hMenuRecentFiles, TPM_LEFTBUTTON, rc.left, rc.bottom, 0, hMainWnd, NULL);
    }
  }
  else if (uMsg == WM_COMMAND)
  {
    if ((HWND)lParam == hToolbar)
    {
      CallToolbarW(&hToolbarStack.hButtonsStack, LOWORD(wParam));
      return TRUE;
    }
  }
  return DefWindowProcW(hWnd, uMsg, wParam, lParam);
}

LRESULT CALLBACK NewToolbarProcA(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  if (uMsg == WM_LBUTTONDBLCLK)
  {
    POINT pt={LOWORD(lParam), HIWORD(lParam)};

    if (SendMessage(hToolbar, TB_HITTEST, 0, (LPARAM)&pt) < 0)
    {
      PostMessage(hToolbarBG, AKDLL_SETUP, 0, 0);
    }
  }
  return CallWindowProcA(OldToolbarProc, hWnd, uMsg, wParam, lParam);
}

LRESULT CALLBACK NewToolbarProcW(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  if (uMsg == WM_LBUTTONDBLCLK)
  {
    POINT pt={LOWORD(lParam), HIWORD(lParam)};

    if (SendMessage(hToolbar, TB_HITTEST, 0, (LPARAM)&pt) < 0)
    {
      PostMessage(hToolbarBG, AKDLL_SETUP, 0, 0);
    }
  }
  return CallWindowProcW(OldToolbarProc, hWnd, uMsg, wParam, lParam);
}

void CreateToolbarA()
{
  WNDCLASSA wndclass={0};
  DWORD dwStyle;

  CreateToolbarDataA(&hToolbarStack, szToolBarText);

  wndclass.style        =CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS;
  wndclass.lpfnWndProc  =ToolbarBGProcA;
  wndclass.cbClsExtra   =0;
  wndclass.cbWndExtra   =DLGWINDOWEXTRA;
  wndclass.hInstance    =hInstanceDLL;
  wndclass.hIcon        =NULL;
  wndclass.hCursor      =LoadCursor(NULL, IDC_ARROW);
  wndclass.hbrBackground=(HBRUSH)(COLOR_BTNFACE + 1);
  wndclass.lpszMenuName =NULL;
  wndclass.lpszClassName=TOOLBARBACKGROUNDA;
  if (!RegisterClassA(&wndclass)) return;

  hToolbarBG=CreateWindowA(TOOLBARBACKGROUNDA,
                        NULL,
                        WS_CHILD|WS_VISIBLE,
                        0, 0, 0, 0,
                        hMainWnd,
                        NULL,
                        hInstanceDLL,
                        NULL);

  hToolbar=CreateWindowA("ToolbarWindow32",
                        NULL,
                        WS_CHILD|WS_VISIBLE|TBSTYLE_TOOLTIPS|(bFlatButtons?TBSTYLE_FLAT:0)|
                        CCS_TOP,
                        0, 0, 0, 0,
                        hToolbarBG,
                        (HMENU)IDC_TOOLBAR,
                        hInstanceDLL,
                        NULL);

  OldToolbarProc=(WNDPROC)GetWindowLongA(hToolbar, GWL_WNDPROC);
  SetWindowLongA(hToolbar, GWL_WNDPROC, (LONG)NewToolbarProcA);

  dwStyle=SendMessage(hToolbar, TB_GETEXTENDEDSTYLE, 0, 0);
  SendMessage(hToolbar, TB_SETEXTENDEDSTYLE, 0, dwStyle|TBSTYLE_EX_DRAWDDARROWS);
  SendMessage(hToolbar, TB_BUTTONSTRUCTSIZE, sizeof(TBBUTTON), 0);

  SetToolbarButtonsA(&hToolbarStack);
  UpdateToolbarA(&hToolbarStack.hButtonsStack);

  hMenuCustomize=CreatePopupMenu();
  AppendMenuA(hMenuCustomize, MF_STRING, IDM_SETUP, GetLangStringA(wLangSystem, STRID_SETUP));
}

void CreateToolbarW()
{
  WNDCLASSW wndclass={0};
  DWORD dwStyle;

  CreateToolbarDataW(&hToolbarStack, wszToolBarText);

  wndclass.style        =CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS;
  wndclass.lpfnWndProc  =ToolbarBGProcW;
  wndclass.cbClsExtra   =0;
  wndclass.cbWndExtra   =DLGWINDOWEXTRA;
  wndclass.hInstance    =hInstanceDLL;
  wndclass.hIcon        =NULL;
  wndclass.hCursor      =LoadCursor(NULL, IDC_ARROW);
  wndclass.hbrBackground=(HBRUSH)(COLOR_BTNFACE + 1);
  wndclass.lpszMenuName =NULL;
  wndclass.lpszClassName=TOOLBARBACKGROUNDW;
  if (!RegisterClassW(&wndclass)) return;

  hToolbarBG=CreateWindowW(TOOLBARBACKGROUNDW,
                        NULL,
                        WS_CHILD|WS_VISIBLE,
                        0, 0, 0, 0,
                        hMainWnd,
                        NULL,
                        hInstanceDLL,
                        NULL);

  hToolbar=CreateWindowW(L"ToolbarWindow32",
                        NULL,
                        WS_CHILD|WS_VISIBLE|TBSTYLE_TOOLTIPS|(bFlatButtons?TBSTYLE_FLAT:0)|
                        CCS_TOP,
                        0, 0, 0, 0,
                        hToolbarBG,
                        (HMENU)IDC_TOOLBAR,
                        hInstanceDLL,
                        NULL);

  OldToolbarProc=(WNDPROC)GetWindowLongW(hToolbar, GWL_WNDPROC);
  SetWindowLongW(hToolbar, GWL_WNDPROC, (LONG)NewToolbarProcW);

  dwStyle=SendMessage(hToolbar, TB_GETEXTENDEDSTYLE, 0, 0);
  SendMessage(hToolbar, TB_SETEXTENDEDSTYLE, 0, dwStyle|TBSTYLE_EX_DRAWDDARROWS);
  SendMessage(hToolbar, TB_BUTTONSTRUCTSIZE, sizeof(TBBUTTON), 0);

  SetToolbarButtonsW(&hToolbarStack);
  UpdateToolbarW(&hToolbarStack.hButtonsStack);

  hMenuCustomize=CreatePopupMenu();
  AppendMenuW(hMenuCustomize, MF_STRING, IDM_SETUP, GetLangStringW(wLangSystem, STRID_SETUP));
}

void CreateToolbarDataA(TOOLBARDATA *hToolbarData, char *pText)
{
  TOOLBARITEMA *lpElement=NULL;
  char szButtonItem[MAX_PATH];
  char szActionName[MAX_PATH];
  char szIconFile[MAX_PATH];
  DWORD dwAction;
  int nPlus;
  int nMinus;
  int nIconIndex;
  int nItemBitmap=0;
  int nItemCommand=0;

  if (pText)
  {
    if (bBigIcons)
      hToolbarData->hImageList=ImageList_Create(32, 32, ILC_COLOR16|ILC_MASK, 0, 0);
    else
      hToolbarData->hImageList=ImageList_Create(16, 16, ILC_COLOR16|ILC_MASK, 0, 0);
    ImageList_SetBkColor(hToolbarData->hImageList, GetSysColor(COLOR_BTNFACE));

    while (*pText)
    {
      while(1)
      {
        while (*pText == ' ' || *pText == '\t' || *pText == '\r') ++pText;

        //Skip comment line
        if (*pText == ';' || *pText == '#')
        {
          while (*pText != '\r' && *pText != '\0') ++pText;
        }
        else break;
      }

      NextStringA(pText, szButtonItem, MAX_PATH, &pText, &nMinus);

      while (*pText == ' ' || *pText == '\t' || *pText == '\r') ++pText;

      if (!lstrcmpA(szButtonItem, "SEPARATOR"))
      {
        if (lpElement=StackInsertButtonA(&hToolbarData->hButtonsStack))
        {
          lpElement->tbb.iBitmap=-1;
          lpElement->tbb.idCommand=0;
          lpElement->tbb.fsState=0;
          lpElement->tbb.fsStyle=TBSTYLE_SEP;
          lpElement->tbb.dwData=0;
          lpElement->tbb.iString=0;
        }
      }
      else
      {
        if (*pText == '+')
        {
          ++pText;
          nPlus=1;
        }
        else nPlus=0;

        dwAction=0;
        GetActionNameA(pText, szActionName, MAX_PATH, &pText);

        if (!lstrcmpiA(szActionName, "Command"))
          dwAction=ACT_COMMAND;
        else if (!lstrcmpiA(szActionName, "Call"))
          dwAction=ACT_CALL;
        else if (!lstrcmpiA(szActionName, "Exec"))
          dwAction=ACT_EXEC;
        else if (!lstrcmpiA(szActionName, "Font"))
          dwAction=ACT_FONT;
        else if (!lstrcmpiA(szActionName, "Recode"))
          dwAction=ACT_RECODE;
        else if (!lstrcmpiA(szActionName, "Insert"))
          dwAction=ACT_INSERT;

        if (dwAction)
        {
          if (lpElement=StackInsertButtonA(&hToolbarData->hButtonsStack))
          {
            lpElement->tbb.iBitmap=-1;
            lpElement->tbb.idCommand=nItemCommand++;
            lpElement->tbb.fsState=TBSTATE_ENABLED;
            lpElement->tbb.fsStyle=TBSTYLE_BUTTON;
            lpElement->tbb.dwData=0;
            lpElement->tbb.iString=0;

            lstrcpynA(lpElement->szButtonItem, szButtonItem, MAX_PATH);
            lpElement->bUpdateItem=!nMinus;
            lpElement->bSetOnStart=nPlus;
            lpElement->dwAction=dwAction;
            GetActionParametersA(&lpElement->hParamStack, pText, &pText);

            if (dwAction == ACT_COMMAND)
            {
              int nCommand=GetParameterInt(&lpElement->hParamStack, 1);

              if (nCommand == IDM_FILE_OPEN)
              {
                lpElement->tbb.fsStyle|=TBSTYLE_DROPDOWN;
              }
              if (!*lpElement->szButtonItem)
              {
                GetMenuStringA(hMainMenu, nCommand, lpElement->szButtonItem, MAX_PATH, MF_BYCOMMAND);
              }
            }
          }
          else break;
        }

        //Icon()
        GetActionNameA(pText, szActionName, MAX_PATH, &pText);

        if (!lstrcmpiA(szActionName, "Icon"))
        {
          HICON hIcon=NULL;

          GetIconParametersA(pText, szIconFile, MAX_PATH, &nIconIndex, &pText);

          if (!*szIconFile)
          {
            if (hIcon=LoadIconA(hInstanceDLL, MAKEINTRESOURCEA(nIconIndex + 100)))
            {
              ImageList_AddIcon(hToolbarData->hImageList, hIcon);
              DestroyIcon(hIcon);
            }
          }
          else
          {
            char szPath[MAX_PATH];
            char *pFileName;

            if (TranslateFileStringA(szIconFile, szPath, MAX_PATH))
            {
              if (SearchPathA(NULL, szPath, NULL, MAX_PATH, szIconFile, &pFileName))
              {
                if (bBigIcons)
                {
                  if ((*ExtractIconExAPtr)(szPath, nIconIndex, &hIcon, NULL, 1))
                  {
                    ImageList_AddIcon(hToolbarData->hImageList, hIcon);
                    DestroyIcon(hIcon);
                  }
                }
                else
                {
                  if ((*ExtractIconExAPtr)(szPath, nIconIndex, NULL, &hIcon, 1))
                  {
                    ImageList_AddIcon(hToolbarData->hImageList, hIcon);
                    DestroyIcon(hIcon);
                  }
                }
              }
            }
          }
          if (hIcon) lpElement->tbb.iBitmap=nItemBitmap++;
        }
      }

      while (1)
      {
        while (*pText == ' ' || *pText == '\t' || *pText == '\r') ++pText;

        //Skip comment line
        if (*pText == ';' || *pText == '#')
        {
          while (*pText != '\r' && *pText != '\0') ++pText;
        }
        else break;
      }
    }
  }
}

void CreateToolbarDataW(TOOLBARDATA *hToolbarData, wchar_t *wpText)
{
  TOOLBARITEMW *lpElement=NULL;
  wchar_t wszButtonItem[MAX_PATH];
  wchar_t wszActionName[MAX_PATH];
  wchar_t wszIconFile[MAX_PATH];
  DWORD dwAction;
  int nPlus;
  int nMinus;
  int nIconIndex;
  int nItemBitmap=0;
  int nItemCommand=0;

  if (wpText)
  {
    if (bBigIcons)
      hToolbarData->hImageList=ImageList_Create(32, 32, ILC_COLOR16|ILC_MASK, 0, 0);
    else
      hToolbarData->hImageList=ImageList_Create(16, 16, ILC_COLOR16|ILC_MASK, 0, 0);
    ImageList_SetBkColor(hToolbarData->hImageList, GetSysColor(COLOR_BTNFACE));

    while (*wpText)
    {
      while(1)
      {
        while (*wpText == ' ' || *wpText == '\t' || *wpText == '\r') ++wpText;

        //Skip comment line
        if (*wpText == ';' || *wpText == '#')
        {
          while (*wpText != '\r' && *wpText != '\0') ++wpText;
        }
        else break;
      }

      NextStringW(wpText, wszButtonItem, MAX_PATH, &wpText, &nMinus);

      while (*wpText == ' ' || *wpText == '\t' || *wpText == '\r') ++wpText;

      if (!lstrcmpW(wszButtonItem, L"SEPARATOR"))
      {
        if (lpElement=StackInsertButtonW(&hToolbarData->hButtonsStack))
        {
          lpElement->tbb.iBitmap=-1;
          lpElement->tbb.idCommand=0;
          lpElement->tbb.fsState=0;
          lpElement->tbb.fsStyle=TBSTYLE_SEP;
          lpElement->tbb.dwData=0;
          lpElement->tbb.iString=0;
        }
      }
      else
      {
        if (*wpText == '+')
        {
          ++wpText;
          nPlus=1;
        }
        else nPlus=0;

        dwAction=0;
        GetActionNameW(wpText, wszActionName, MAX_PATH, &wpText);

        if (!lstrcmpiW(wszActionName, L"Command"))
          dwAction=ACT_COMMAND;
        else if (!lstrcmpiW(wszActionName, L"Call"))
          dwAction=ACT_CALL;
        else if (!lstrcmpiW(wszActionName, L"Exec"))
          dwAction=ACT_EXEC;
        else if (!lstrcmpiW(wszActionName, L"Font"))
          dwAction=ACT_FONT;
        else if (!lstrcmpiW(wszActionName, L"Recode"))
          dwAction=ACT_RECODE;
        else if (!lstrcmpiW(wszActionName, L"Insert"))
          dwAction=ACT_INSERT;

        if (dwAction)
        {
          if (lpElement=StackInsertButtonW(&hToolbarData->hButtonsStack))
          {
            lpElement->tbb.iBitmap=-1;
            lpElement->tbb.idCommand=nItemCommand++;
            lpElement->tbb.fsState=TBSTATE_ENABLED;
            lpElement->tbb.fsStyle=TBSTYLE_BUTTON;
            lpElement->tbb.dwData=0;
            lpElement->tbb.iString=0;

            lstrcpynW(lpElement->wszButtonItem, wszButtonItem, MAX_PATH);
            lpElement->bUpdateItem=!nMinus;
            lpElement->bSetOnStart=nPlus;
            lpElement->dwAction=dwAction;
            GetActionParametersW(&lpElement->hParamStack, wpText, &wpText);

            if (dwAction == ACT_COMMAND)
            {
              int nCommand=GetParameterInt(&lpElement->hParamStack, 1);

              if (nCommand == IDM_FILE_OPEN)
              {
                lpElement->tbb.fsStyle|=TBSTYLE_DROPDOWN;
              }
              if (!*lpElement->wszButtonItem)
              {
                GetMenuStringW(hMainMenu, nCommand, lpElement->wszButtonItem, MAX_PATH, MF_BYCOMMAND);
              }
            }
          }
          else break;
        }

        //Icon()
        GetActionNameW(wpText, wszActionName, MAX_PATH, &wpText);

        if (!lstrcmpiW(wszActionName, L"Icon"))
        {
          HICON hIcon=NULL;

          GetIconParametersW(wpText, wszIconFile, MAX_PATH, &nIconIndex, &wpText);

          if (!*wszIconFile)
          {
            if (hIcon=LoadIconW(hInstanceDLL, MAKEINTRESOURCEW(nIconIndex + 100)))
            {
              ImageList_AddIcon(hToolbarData->hImageList, hIcon);
              DestroyIcon(hIcon);
            }
          }
          else
          {
            wchar_t wszPath[MAX_PATH];
            wchar_t *wpFileName;

            if (TranslateFileStringW(wszIconFile, wszPath, MAX_PATH))
            {
              if (SearchPathW(NULL, wszPath, NULL, MAX_PATH, wszIconFile, &wpFileName))
              {
                if (bBigIcons)
                {
                  if ((*ExtractIconExWPtr)(wszPath, nIconIndex, &hIcon, NULL, 1))
                  {
                    ImageList_AddIcon(hToolbarData->hImageList, hIcon);
                    DestroyIcon(hIcon);
                  }
                }
                else
                {
                  if ((*ExtractIconExWPtr)(wszPath, nIconIndex, NULL, &hIcon, 1))
                  {
                    ImageList_AddIcon(hToolbarData->hImageList, hIcon);
                    DestroyIcon(hIcon);
                  }
                }
              }
            }
          }
          if (hIcon) lpElement->tbb.iBitmap=nItemBitmap++;
        }
      }

      while (1)
      {
        while (*wpText == ' ' || *wpText == '\t' || *wpText == '\r') ++wpText;

        //Skip comment line
        if (*wpText == ';' || *wpText == '#')
        {
          while (*wpText != '\r' && *wpText != '\0') ++wpText;
        }
        else break;
      }
    }
  }
}

void FreeToolbarDataA(TOOLBARDATA *hToolbarData)
{
  StackFreeButtonA(&hToolbarData->hButtonsStack);
  ImageList_Destroy(hToolbarData->hImageList);
}

void FreeToolbarDataW(TOOLBARDATA *hToolbarData)
{
  StackFreeButtonW(&hToolbarData->hButtonsStack);
  ImageList_Destroy(hToolbarData->hImageList);
}

void SetToolbarButtonsA(TOOLBARDATA *hToolbarData)
{
  TOOLBARITEMA *lpElement=(TOOLBARITEMA *)hToolbarData->hButtonsStack.first;

  if (bBigIcons)
  {
    SendMessage(hToolbar, TB_SETBITMAPSIZE, 0, MAKELONG(32, 32));
    SendMessage(hToolbar, TB_SETBUTTONSIZE, 0, MAKELONG(40, 38));
    nToolbarHeight=44;
  }
  else
  {
    SendMessage(hToolbar, TB_SETBITMAPSIZE, 0, MAKELONG(16, 16));
    SendMessage(hToolbar, TB_SETBUTTONSIZE, 0, MAKELONG(24, 22));
    nToolbarHeight=28;
  }
  SendMessage(hToolbar, TB_SETIMAGELIST, 0, (LPARAM)hToolbarData->hImageList);

  while (lpElement)
  {
    SendMessage(hToolbar, TB_ADDBUTTONS, 1, (LPARAM)&lpElement->tbb);

    lpElement=lpElement->next;
  }
}

void SetToolbarButtonsW(TOOLBARDATA *hToolbarData)
{
  TOOLBARITEMW *lpElement=(TOOLBARITEMW *)hToolbarData->hButtonsStack.first;

  if (bBigIcons)
  {
    SendMessage(hToolbar, TB_SETBITMAPSIZE, 0, MAKELONG(32, 32));
    SendMessage(hToolbar, TB_SETBUTTONSIZE, 0, MAKELONG(40, 38));
    nToolbarHeight=44;
  }
  else
  {
    SendMessage(hToolbar, TB_SETBITMAPSIZE, 0, MAKELONG(16, 16));
    SendMessage(hToolbar, TB_SETBUTTONSIZE, 0, MAKELONG(24, 22));
    nToolbarHeight=28;
  }
  SendMessage(hToolbar, TB_SETIMAGELIST, 0, (LPARAM)hToolbarData->hImageList);

  while (lpElement)
  {
    SendMessage(hToolbar, TB_ADDBUTTONS, 1, (LPARAM)&lpElement->tbb);

    lpElement=lpElement->next;
  }
}

void ClearToolbarButtons()
{
  while (SendMessage(hToolbar, TB_DELETEBUTTON, 0, 0));
}

void UpdateToolbarA(HSTACK *hStack)
{
  TOOLBARITEMA *lpElement=(TOOLBARITEMA *)hStack->first;
  BOOL bInitMenu=FALSE;

  while (lpElement)
  {
    if (lpElement->bUpdateItem)
    {
      if (lpElement->dwAction == ACT_COMMAND)
      {
        int nCommand=0;
        DWORD dwMenuState;
        DWORD dwToolState;

        nCommand=GetParameterInt(&lpElement->hParamStack, 1);

        if (nCommand)
        {
          if (!bInitMenu)
          {
            SendMessage(hMainWnd, WM_INITMENU, (WPARAM)hMainMenu, IMENU_EDIT|IMENU_CHECKS);
            bInitMenu=TRUE;
          }

          dwMenuState=GetMenuState(hMainMenu, nCommand, MF_BYCOMMAND);
          dwToolState=SendMessage(hToolbar, TB_GETSTATE, lpElement->tbb.idCommand, 0);

          if (!(dwMenuState & MF_GRAYED) == !(dwToolState & TBSTATE_ENABLED))
            SendMessage(hToolbar, TB_ENABLEBUTTON, lpElement->tbb.idCommand, (dwMenuState & MF_GRAYED)?FALSE:TRUE);
          if (!(dwMenuState & MF_CHECKED) != !(dwToolState & TBSTATE_CHECKED))
            SendMessage(hToolbar, TB_CHECKBUTTON, lpElement->tbb.idCommand, (dwMenuState & MF_CHECKED)?TRUE:FALSE);
        }
      }
      else if (lpElement->dwAction == ACT_CALL)
      {
        PLUGINFUNCTIONA *pf;
        char *pFunction=NULL;
        BOOL bChecked;

        pFunction=(char *)GetParameterChar(&lpElement->hParamStack, 1);

        if (pFunction)
        {
          bChecked=FALSE;
          if (pf=(PLUGINFUNCTIONA *)SendMessage(hMainWnd, AKD_DLLFIND, (WPARAM)pFunction, 0))
            if (pf->bRunning) bChecked=TRUE;
          SendMessage(hToolbar, TB_CHECKBUTTON, lpElement->tbb.idCommand, bChecked);
        }
      }
    }
    lpElement=lpElement->next;
  }
}

void UpdateToolbarW(HSTACK *hStack)
{
  TOOLBARITEMW *lpElement=(TOOLBARITEMW *)hStack->first;
  BOOL bInitMenu=FALSE;

  while (lpElement)
  {
    if (lpElement->bUpdateItem)
    {
      if (lpElement->dwAction == ACT_COMMAND)
      {
        int nCommand=0;
        DWORD dwMenuState;
        DWORD dwToolState;

        nCommand=GetParameterInt(&lpElement->hParamStack, 1);

        if (nCommand)
        {
          if (!bInitMenu)
          {
            SendMessage(hMainWnd, WM_INITMENU, (WPARAM)hMainMenu, IMENU_EDIT|IMENU_CHECKS);
            bInitMenu=TRUE;
          }

          dwMenuState=GetMenuState(hMainMenu, nCommand, MF_BYCOMMAND);
          dwToolState=SendMessage(hToolbar, TB_GETSTATE, lpElement->tbb.idCommand, 0);

          if (!(dwMenuState & MF_GRAYED) == !(dwToolState & TBSTATE_ENABLED))
            SendMessage(hToolbar, TB_ENABLEBUTTON, lpElement->tbb.idCommand, (dwMenuState & MF_GRAYED)?FALSE:TRUE);
          if (!(dwMenuState & MF_CHECKED) != !(dwToolState & TBSTATE_CHECKED))
            SendMessage(hToolbar, TB_CHECKBUTTON, lpElement->tbb.idCommand, (dwMenuState & MF_CHECKED)?TRUE:FALSE);
        }
      }
      else if (lpElement->dwAction == ACT_CALL)
      {
        PLUGINFUNCTIONW *pf;
        wchar_t *wpFunction=NULL;
        BOOL bChecked;

        wpFunction=(wchar_t *)GetParameterChar(&lpElement->hParamStack, 1);

        if (wpFunction)
        {
          bChecked=FALSE;
          if (pf=(PLUGINFUNCTIONW *)SendMessage(hMainWnd, AKD_DLLFIND, (WPARAM)wpFunction, 0))
            if (pf->bRunning) bChecked=TRUE;
          SendMessage(hToolbar, TB_CHECKBUTTON, lpElement->tbb.idCommand, bChecked);
        }
      }
    }
    lpElement=lpElement->next;
  }
}

void CALLBACK CallPluginA(void *lpParameter)
{
  PLUGINCALL *pc=(PLUGINCALL *)lpParameter;
  PLUGINCALLSENDA pcs;
  char szMessage[MAX_PATH];
  char *pFunction;
  int nParamStructSize;
  LPARAM lParam;
  BOOL bAutoLoad;

  pFunction=(char *)*(int *)pc->lpStruct;
  nParamStructSize=*(int *)(pc->lpStruct + sizeof(int));
  if (nParamStructSize > (int)sizeof(int))
    lParam=(LPARAM)(pc->lpStruct + sizeof(int));
  else
    lParam=0;

  if (pc->bSetOnStart)
  {
    pcs.pFunction=pFunction;
    pcs.bOnStart=FALSE;
    pcs.lParam=0;
    pcs.lpbAutoLoad=&bAutoLoad;

    if (SendMessage(hMainWnd, AKD_DLLCALL, 0, (LPARAM)&pcs) != UD_FAILED)
    {
      if (bAutoLoad)
      {
        PLUGINFUNCTIONA *pf;

        pcs.pFunction=pFunction;
        pcs.bOnStart=pc->bOnStart;
        pcs.lParam=lParam;
        pcs.lpbAutoLoad=NULL;
        SendMessage(hMainWnd, AKD_DLLCALL, 0, (LPARAM)&pcs);

        if (pf=(PLUGINFUNCTIONA *)SendMessage(hMainWnd, AKD_DLLFIND, (WPARAM)pFunction, 0))
        {
          if (pf->bRunning)
            pf->bOnStart=TRUE;
          else
            pf->bOnStart=FALSE;

          SendMessage(hMainWnd, AKD_DLLSAVE, 0, DLLS_CLEAR);
        }
      }
      else
      {
        wsprintfA(szMessage, GetLangStringA(wLangSystem, STRID_AUTOLOAD), pFunction);
        MessageBoxA(hMainWnd, szMessage, "ContextMenu plugin", MB_OK|MB_ICONEXCLAMATION);
      }
    }
  }
  else
  {
    pcs.pFunction=pFunction;
    pcs.bOnStart=pc->bOnStart;
    pcs.lParam=lParam;
    pcs.lpbAutoLoad=NULL;
    SendMessage(hMainWnd, AKD_DLLCALL, 0, (LPARAM)&pcs);
  }
  GlobalFree((HGLOBAL)pc->lpStruct);
  GlobalFree((HGLOBAL)pc);
}

void CALLBACK CallPluginW(void *lpParameter)
{
  PLUGINCALL *pc=(PLUGINCALL *)lpParameter;
  PLUGINCALLSENDW pcs;
  wchar_t wszMessage[MAX_PATH];
  wchar_t *wpFunction;
  int nParamStructSize;
  LPARAM lParam;
  BOOL bAutoLoad;

  wpFunction=(wchar_t *)*(int *)pc->lpStruct;
  nParamStructSize=*(int *)(pc->lpStruct + sizeof(int));
  if (nParamStructSize > (int)sizeof(int))
    lParam=(LPARAM)(pc->lpStruct + sizeof(int));
  else
    lParam=0;

  if (pc->bSetOnStart)
  {
    pcs.pFunction=wpFunction;
    pcs.bOnStart=FALSE;
    pcs.lParam=0;
    pcs.lpbAutoLoad=&bAutoLoad;

    if (SendMessage(hMainWnd, AKD_DLLCALL, 0, (LPARAM)&pcs) != UD_FAILED)
    {
      if (bAutoLoad)
      {
        PLUGINFUNCTIONW *pf;

        pcs.pFunction=wpFunction;
        pcs.bOnStart=pc->bOnStart;
        pcs.lParam=lParam;
        pcs.lpbAutoLoad=NULL;
        SendMessage(hMainWnd, AKD_DLLCALL, 0, (LPARAM)&pcs);

        if (pf=(PLUGINFUNCTIONW *)SendMessage(hMainWnd, AKD_DLLFIND, (WPARAM)wpFunction, 0))
        {
          if (pf->bRunning)
            pf->bOnStart=TRUE;
          else
            pf->bOnStart=FALSE;

          SendMessage(hMainWnd, AKD_DLLSAVE, 0, DLLS_CLEAR);
        }
      }
      else
      {
        wsprintfW(wszMessage, GetLangStringW(wLangSystem, STRID_AUTOLOAD), wpFunction);
        MessageBoxW(hMainWnd, wszMessage, L"ContextMenu plugin", MB_OK|MB_ICONEXCLAMATION);
      }
    }
  }
  else
  {
    pcs.pFunction=wpFunction;
    pcs.bOnStart=pc->bOnStart;
    pcs.lParam=lParam;
    pcs.lpbAutoLoad=NULL;
    SendMessage(hMainWnd, AKD_DLLCALL, 0, (LPARAM)&pcs);
  }
  GlobalFree((HGLOBAL)pc->lpStruct);
  GlobalFree((HGLOBAL)pc);
}

void CallToolbarA(HSTACK *hStack, int nItem)
{
  TOOLBARITEMA *lpElement;
  EDITINFO ei;
  char szCurrentFile[MAX_PATH]="";
  char szToolbarID[16];
  char szItemID[16];

  if (lpElement=StackGetButtonA(hStack, nItem))
  {
    wsprintfA(szToolbarID, "%d", hToolbar);
    wsprintfA(szItemID, "%d", lpElement->tbb.idCommand);

    if (lpElement->dwAction == ACT_COMMAND)
    {
      int nCommand=0;

      nCommand=GetParameterInt(&lpElement->hParamStack, 1);

      if (nCommand)
      {
        SendMessage(hMainWnd, WM_COMMAND, nCommand, 0);
      }
    }
    else if (lpElement->dwAction == ACT_CALL)
    {
      PLUGINCALL *pc;
      unsigned char *lpStruct=NULL;

      if (SendMessage(hMainWnd, AKD_GETEDITINFO, (WPARAM)NULL, (LPARAM)&ei))
      {
        lstrcpynA(szCurrentFile, (char *)ei.pFile, MAX_PATH);
      }
      SetParametersExpCharA(&lpElement->hParamStack, szCurrentFile, szExeDir, szToolbarID, szItemID);

      if (CreateParametersStruct(&lpElement->hParamStack, &lpStruct))
      {
        if (pc=(PLUGINCALL *)GlobalAlloc(GPTR, sizeof(PLUGINCALL)))
        {
          pc->lpStruct=lpStruct;
          pc->bOnStart=FALSE;
          pc->bSetOnStart=lpElement->bSetOnStart;
          PostMessage(hMainWnd, AKD_CALLPROC, (WPARAM)CallPluginA, (LPARAM)pc);
        }
      }
    }
    else if (lpElement->dwAction == ACT_EXEC)
    {
      STARTUPINFOA si={0};
      PROCESS_INFORMATION pi={0};
      char *pCmdLine=NULL;
      char *pWorkDir=NULL;

      if (SendMessage(hMainWnd, AKD_GETEDITINFO, (WPARAM)NULL, (LPARAM)&ei))
      {
        lstrcpynA(szCurrentFile, (char *)ei.pFile, MAX_PATH);
      }
      SetParametersExpCharA(&lpElement->hParamStack, szCurrentFile, szExeDir, szToolbarID, szItemID);
      pCmdLine=(char *)GetParameterExpChar(&lpElement->hParamStack, 1);
      pWorkDir=(char *)GetParameterExpChar(&lpElement->hParamStack, 2);

      if (pCmdLine)
      {
        si.cb=sizeof(STARTUPINFO);
        if (CreateProcessA(NULL, pCmdLine, NULL, NULL, FALSE, 0, NULL, pWorkDir, &si, &pi))
        {
          CloseHandle(pi.hProcess);
          CloseHandle(pi.hThread);
        }
      }
    }
    else if (lpElement->dwAction == ACT_FONT)
    {
      EDITINFO ei;
      char *pFaceName=NULL;
      DWORD dwFontStyle=0;
      int nPointSize=0;

      SetParametersExpCharA(&lpElement->hParamStack, szCurrentFile, szExeDir, szToolbarID, szItemID);
      pFaceName=(char *)GetParameterExpChar(&lpElement->hParamStack, 1);
      dwFontStyle=GetParameterInt(&lpElement->hParamStack, 2);
      nPointSize=GetParameterInt(&lpElement->hParamStack, 3);

      if (SendMessage(hMainWnd, AKD_GETEDITINFO, (WPARAM)NULL, (LPARAM)&ei))
      {
        LOGFONTA lfNew={0};
        LOGFONTA *lfCur;
        HDC hDC;

        lfCur=(LOGFONTA *)SendMessage(hMainWnd, AKD_GETFONT, (WPARAM)ei.hWndEdit, 0);
        memcpy(&lfNew, lfCur, sizeof(LOGFONTA));

        if (nPointSize)
        {
          if (hDC=GetDC(ei.hWndEdit))
          {
            lfNew.lfHeight=-MulDiv(nPointSize, GetDeviceCaps(hDC, LOGPIXELSY), 72);
            ReleaseDC(ei.hWndEdit, hDC);
          }
        }
        if (dwFontStyle != FS_NONE)
        {
          lfNew.lfWeight=(dwFontStyle == FS_FONTBOLD || dwFontStyle == FS_FONTBOLDITALIC)?FW_BOLD:FW_NORMAL;
          lfNew.lfItalic=(dwFontStyle == FS_FONTITALIC || dwFontStyle == FS_FONTBOLDITALIC)?TRUE:FALSE;
        }
        if (*pFaceName != '\0')
        {
          lstrcpynA(lfNew.lfFaceName, pFaceName, LF_FACESIZE);
        }
        SendMessage(hMainWnd, AKD_SETFONT, (WPARAM)ei.hWndEdit, (LPARAM)&lfNew);
      }
    }
    else if (lpElement->dwAction == ACT_RECODE)
    {
      TEXTRECODE tr;
      EDITINFO ei;

      tr.nCodePageFrom=GetParameterInt(&lpElement->hParamStack, 1);
      tr.nCodePageTo=GetParameterInt(&lpElement->hParamStack, 2);

      if (SendMessage(hMainWnd, AKD_GETEDITINFO, (WPARAM)NULL, (LPARAM)&ei))
      {
        SendMessage(hMainWnd, AKD_RECODESEL, (WPARAM)ei.hWndEdit, (LPARAM)&tr);
      }
    }
    else if (lpElement->dwAction == ACT_INSERT)
    {
      EDITINFO ei;
      char *pText=NULL;

      SetParametersExpCharA(&lpElement->hParamStack, szCurrentFile, szExeDir, szToolbarID, szItemID);
      pText=(char *)GetParameterExpChar(&lpElement->hParamStack, 1);

      if (SendMessage(hMainWnd, AKD_GETEDITINFO, (WPARAM)NULL, (LPARAM)&ei))
      {
        SendMessage(hMainWnd, AKD_REPLACESELA, (WPARAM)ei.hWndEdit, (LPARAM)pText);
      }
    }
  }
}

void CallToolbarW(HSTACK *hStack, int nItem)
{
  TOOLBARITEMW *lpElement;
  EDITINFO ei;
  wchar_t wszCurrentFile[MAX_PATH];
  wchar_t wszToolbarID[16];
  wchar_t wszItemID[16];

  if (lpElement=StackGetButtonW(hStack, nItem))
  {
    wsprintfW(wszToolbarID, L"%d", hToolbar);
    wsprintfW(wszItemID, L"%d", lpElement->tbb.idCommand);

    if (lpElement->dwAction == ACT_COMMAND)
    {
      int nCommand=0;

      nCommand=GetParameterInt(&lpElement->hParamStack, 1);

      if (nCommand)
      {
        SendMessage(hMainWnd, WM_COMMAND, nCommand, 0);
      }
    }
    else if (lpElement->dwAction == ACT_CALL)
    {
      PLUGINCALL *pc;
      unsigned char *lpStruct=NULL;

      if (SendMessage(hMainWnd, AKD_GETEDITINFO, (WPARAM)NULL, (LPARAM)&ei))
      {
        lstrcpynW(wszCurrentFile, (wchar_t *)ei.pFile, MAX_PATH);
      }
      SetParametersExpCharW(&lpElement->hParamStack, wszCurrentFile, wszExeDir, wszToolbarID, wszItemID);

      if (CreateParametersStruct(&lpElement->hParamStack, &lpStruct))
      {
        if (pc=(PLUGINCALL *)GlobalAlloc(GPTR, sizeof(PLUGINCALL)))
        {
          pc->lpStruct=lpStruct;
          pc->bOnStart=FALSE;
          pc->bSetOnStart=lpElement->bSetOnStart;
          PostMessage(hMainWnd, AKD_CALLPROC, (WPARAM)CallPluginW, (LPARAM)pc);
        }
      }
    }
    else if (lpElement->dwAction == ACT_EXEC)
    {
      STARTUPINFOW si={0};
      PROCESS_INFORMATION pi={0};
      wchar_t *wpCmdLine=NULL;
      wchar_t *wpWorkDir=NULL;

      if (SendMessage(hMainWnd, AKD_GETEDITINFO, (WPARAM)NULL, (LPARAM)&ei))
      {
        lstrcpynW(wszCurrentFile, (wchar_t *)ei.pFile, MAX_PATH);
      }
      SetParametersExpCharW(&lpElement->hParamStack, wszCurrentFile, wszExeDir, wszToolbarID, wszItemID);
      wpCmdLine=(wchar_t *)GetParameterExpChar(&lpElement->hParamStack, 1);
      wpWorkDir=(wchar_t *)GetParameterExpChar(&lpElement->hParamStack, 2);

      if (wpCmdLine)
      {
        si.cb=sizeof(STARTUPINFOW);
        if (CreateProcessW(NULL, wpCmdLine, NULL, NULL, FALSE, 0, NULL, wpWorkDir, &si, &pi))
        {
          CloseHandle(pi.hProcess);
          CloseHandle(pi.hThread);
        }
      }
    }
    else if (lpElement->dwAction == ACT_FONT)
    {
      EDITINFO ei;
      wchar_t *wpFaceName=NULL;
      DWORD dwFontStyle=0;
      int nPointSize=0;

      SetParametersExpCharW(&lpElement->hParamStack, wszCurrentFile, wszExeDir, wszToolbarID, wszItemID);
      wpFaceName=(wchar_t *)GetParameterExpChar(&lpElement->hParamStack, 1);
      dwFontStyle=GetParameterInt(&lpElement->hParamStack, 2);
      nPointSize=GetParameterInt(&lpElement->hParamStack, 3);

      if (SendMessage(hMainWnd, AKD_GETEDITINFO, (WPARAM)NULL, (LPARAM)&ei))
      {
        LOGFONTW lfNew={0};
        LOGFONTW *lfCur;
        HDC hDC;

        lfCur=(LOGFONTW *)SendMessage(hMainWnd, AKD_GETFONT, (WPARAM)ei.hWndEdit, 0);
        memcpy(&lfNew, lfCur, sizeof(LOGFONTW));

        if (nPointSize)
        {
          if (hDC=GetDC(ei.hWndEdit))
          {
            lfNew.lfHeight=-MulDiv(nPointSize, GetDeviceCaps(hDC, LOGPIXELSY), 72);
            ReleaseDC(ei.hWndEdit, hDC);
          }
        }
        if (dwFontStyle != FS_NONE)
        {
          lfNew.lfWeight=(dwFontStyle == FS_FONTBOLD || dwFontStyle == FS_FONTBOLDITALIC)?FW_BOLD:FW_NORMAL;
          lfNew.lfItalic=(dwFontStyle == FS_FONTITALIC || dwFontStyle == FS_FONTBOLDITALIC)?TRUE:FALSE;
        }
        if (*wpFaceName != '\0')
        {
          lstrcpynW(lfNew.lfFaceName, wpFaceName, LF_FACESIZE);
        }
        SendMessage(hMainWnd, AKD_SETFONT, (WPARAM)ei.hWndEdit, (LPARAM)&lfNew);
      }
    }
    else if (lpElement->dwAction == ACT_RECODE)
    {
      TEXTRECODE tr;
      EDITINFO ei;

      tr.nCodePageFrom=GetParameterInt(&lpElement->hParamStack, 1);
      tr.nCodePageTo=GetParameterInt(&lpElement->hParamStack, 2);

      if (SendMessage(hMainWnd, AKD_GETEDITINFO, (WPARAM)NULL, (LPARAM)&ei))
      {
        SendMessage(hMainWnd, AKD_RECODESEL, (WPARAM)ei.hWndEdit, (LPARAM)&tr);
      }
    }
    else if (lpElement->dwAction == ACT_INSERT)
    {
      EDITINFO ei;
      wchar_t *wpText=NULL;

      SetParametersExpCharW(&lpElement->hParamStack, wszCurrentFile, wszExeDir, wszToolbarID, wszItemID);
      wpText=(wchar_t *)GetParameterExpChar(&lpElement->hParamStack, 1);

      if (SendMessage(hMainWnd, AKD_GETEDITINFO, (WPARAM)NULL, (LPARAM)&ei))
      {
        SendMessage(hMainWnd, AKD_REPLACESELW, (WPARAM)ei.hWndEdit, (LPARAM)wpText);
      }
    }
  }
}

void DestroyToolbarA()
{
  DestroyMenu(hMenuCustomize);
  DestroyWindow(hToolbar);
  hToolbar=NULL;
  DestroyWindow(hToolbarBG);
  hToolbarBG=NULL;
  UnregisterClassA(TOOLBARBACKGROUNDA, hInstanceDLL);
  FreeToolbarDataA(&hToolbarStack);

  if (szToolBarText)
  {
    GlobalFree((HGLOBAL)szToolBarText);
    szToolBarText=NULL;
  }
}

void DestroyToolbarW()
{
  DestroyMenu(hMenuCustomize);
  DestroyWindow(hToolbar);
  hToolbar=NULL;
  DestroyWindow(hToolbarBG);
  hToolbarBG=NULL;
  UnregisterClassW(TOOLBARBACKGROUNDW, hInstanceDLL);
  FreeToolbarDataW(&hToolbarStack);

  if (wszToolBarText)
  {
    GlobalFree((HGLOBAL)wszToolBarText);
    wszToolBarText=NULL;
  }
}

TOOLBARITEMA* StackInsertButtonA(HSTACK *hStack)
{
  TOOLBARITEMA *lpElement=NULL;

  StackInsertIndex((stack **)&hStack->first, (stack **)&hStack->last, (stack **)&lpElement, -1, sizeof(TOOLBARITEMA));
  return lpElement;
}

TOOLBARITEMW* StackInsertButtonW(HSTACK *hStack)
{
  TOOLBARITEMW *lpElement=NULL;

  StackInsertIndex((stack **)&hStack->first, (stack **)&hStack->last, (stack **)&lpElement, -1, sizeof(TOOLBARITEMW));
  return lpElement;
}

TOOLBARITEMA* StackGetButtonA(HSTACK *hStack, int nItemID)
{
  TOOLBARITEMA *lpElement=(TOOLBARITEMA *)hStack->first;

  while (lpElement)
  {
    if (lpElement->tbb.idCommand == nItemID)
      return lpElement;

    lpElement=lpElement->next;
  }
  return NULL;
}

TOOLBARITEMW* StackGetButtonW(HSTACK *hStack, int nItemID)
{
  TOOLBARITEMW *lpElement=(TOOLBARITEMW *)hStack->first;

  while (lpElement)
  {
    if (lpElement->tbb.idCommand == nItemID)
      return lpElement;

    lpElement=lpElement->next;
  }
  return NULL;
}

void StackFreeButtonA(HSTACK *hStack)
{
  TOOLBARITEMA *lpElement=(TOOLBARITEMA *)hStack->first;

  while (lpElement)
  {
    FreeActionParameters(&lpElement->hParamStack);

    lpElement=lpElement->next;
  }
  StackClear((stack **)&hStack->first, (stack **)&hStack->last);
}

void StackFreeButtonW(HSTACK *hStack)
{
  TOOLBARITEMW *lpElement=(TOOLBARITEMW *)hStack->first;

  while (lpElement)
  {
    FreeActionParameters(&lpElement->hParamStack);

    lpElement=lpElement->next;
  }
  StackClear((stack **)&hStack->first, (stack **)&hStack->last);
}

void GetActionParametersA(HSTACK *hParamStack, char *pText, char **ppText)
{
  PARAMETER *lpParameter;
  char *pParamBegin=pText;
  char *pParamEnd;
  char *pString;
  char chStopChar;
  int nStringLen;

  GetActionParameter:
  while (*pParamBegin == ' ' || *pParamBegin == '\t') ++pParamBegin;

  if (*pParamBegin == '\"' || *pParamBegin == '\'' || *pParamBegin == '`')
  {
    //String
    chStopChar=*pParamBegin++;
    nStringLen=0;

    for (pParamEnd=pParamBegin; *pParamEnd != chStopChar && *pParamEnd != '\0'; ++pParamEnd)
    {
      ++nStringLen;
    }

    if (!StackInsertIndex((stack **)&hParamStack->first, (stack **)&hParamStack->last, (stack **)&lpParameter, -1, sizeof(PARAMETER)))
    {
      if (lpParameter->lParam=(LPARAM)GlobalAlloc(GPTR, nStringLen + 1))
      {
        lpParameter->dwType=PARAM_CHAR;
        pString=(char *)lpParameter->lParam;

        for (pParamEnd=pParamBegin; *pParamEnd != chStopChar && *pParamEnd != '\0'; ++pParamEnd)
        {
          *pString++=*pParamEnd;
        }
      }
    }
  }
  else
  {
    //Number
    for (pParamEnd=pParamBegin; *pParamEnd != ',' && *pParamEnd != ')' && *pParamEnd != '\0'; ++pParamEnd);

    if (!StackInsertIndex((stack **)&hParamStack->first, (stack **)&hParamStack->last, (stack **)&lpParameter, -1, sizeof(PARAMETER)))
    {
      lpParameter->dwType=PARAM_INT;
      lpParameter->lParam=xatoiA(pParamBegin);
    }
  }

  while (*pParamEnd != ',' && *pParamEnd != ')' && *pParamEnd != '\0')
    ++pParamEnd;
  if (*pParamEnd == ',')
  {
    pParamBegin=++pParamEnd;
    goto GetActionParameter;
  }
  if (*pParamEnd == ')')
    ++pParamEnd;
  *ppText=pParamEnd;
}

void GetActionParametersW(HSTACK *hParamStack, wchar_t *wpText, wchar_t **wppText)
{
  PARAMETER *lpParameter;
  wchar_t *wpParamBegin=wpText;
  wchar_t *wpParamEnd;
  wchar_t *wpString;
  wchar_t wchStopChar;
  int nStringLen;

  GetActionParameter:
  while (*wpParamBegin == ' ' || *wpParamBegin == '\t') ++wpParamBegin;

  if (*wpParamBegin == '\"' || *wpParamBegin == '\'' || *wpParamBegin == '`')
  {
    //String
    wchStopChar=*wpParamBegin++;
    nStringLen=0;

    for (wpParamEnd=wpParamBegin; *wpParamEnd != wchStopChar && *wpParamEnd != '\0'; ++wpParamEnd)
    {
      ++nStringLen;
    }

    if (!StackInsertIndex((stack **)&hParamStack->first, (stack **)&hParamStack->last, (stack **)&lpParameter, -1, sizeof(PARAMETER)))
    {
      if (lpParameter->lParam=(LPARAM)GlobalAlloc(GPTR, (nStringLen + 1) * sizeof(wchar_t)))
      {
        lpParameter->dwType=PARAM_CHAR;
        wpString=(wchar_t *)lpParameter->lParam;

        for (wpParamEnd=wpParamBegin; *wpParamEnd != wchStopChar && *wpParamEnd != '\0'; ++wpParamEnd)
        {
          *wpString++=*wpParamEnd;
        }
      }
    }
  }
  else
  {
    //Number
    for (wpParamEnd=wpParamBegin; *wpParamEnd != ',' && *wpParamEnd != ')' && *wpParamEnd != '\0'; ++wpParamEnd);

    if (!StackInsertIndex((stack **)&hParamStack->first, (stack **)&hParamStack->last, (stack **)&lpParameter, -1, sizeof(PARAMETER)))
    {
      lpParameter->dwType=PARAM_INT;
      lpParameter->lParam=xatoiW(wpParamBegin);
    }
  }

  while (*wpParamEnd != ',' && *wpParamEnd != ')' && *wpParamEnd != '\0')
    ++wpParamEnd;
  if (*wpParamEnd == ',')
  {
    wpParamBegin=++wpParamEnd;
    goto GetActionParameter;
  }
  if (*wpParamEnd == ')')
    ++wpParamEnd;
  *wppText=wpParamEnd;
}

void SetParametersExpCharA(HSTACK *hParamStack, char *pFile, char *pExeDir, char *pToolbarID, char *pItemID)
{
  //%f -file, %d -file directory, %a -AkelPad directory, %% -%
  PARAMETER *lpParameter=(PARAMETER *)hParamStack->first;
  char szFileDir[MAX_PATH];
  char *szString;
  char *pCount;
  char *pExpandStr=NULL;
  char chTmp;
  int nFileLen;
  int nFileDirLen;
  int nExeDirLen;
  int nToolbarIDLen;
  int nItemIDLen;
  int nExpandStrLen;
  int nEnvironmentLen;

  nFileLen=lstrlenA(pFile);
  nFileDirLen=GetFileDirA(pFile, szFileDir, MAX_PATH);
  nExeDirLen=lstrlenA(pExeDir);
  nToolbarIDLen=lstrlenA(pToolbarID);
  nItemIDLen=lstrlenA(pItemID);
  nExpandStrLen=0;

  while (lpParameter)
  {
    if (lpParameter->dwType == PARAM_CHAR)
    {
      nEnvironmentLen=ExpandEnvironmentStringsA((char *)lpParameter->lParam, &chTmp, 0);

      if (szString=(char *)GlobalAlloc(GPTR, nEnvironmentLen))
      {
        //Expand environment strings
        ExpandEnvironmentStringsA((char *)lpParameter->lParam, szString, nEnvironmentLen);

        //Calculate expanded size
        for (pCount=szString; *pCount; ++pCount)
        {
          if (*pCount == '%')
          {
            if (*(pCount + 1) == '%')
            {
              ++pCount;
              ++nExpandStrLen;
              continue;
            }
            if (*(pCount + 1) == 'f' || *(pCount + 1) == 'F')
            {
              ++pCount;
              nExpandStrLen+=nFileLen;
              continue;
            }
            if (*(pCount + 1) == 'd' || *(pCount + 1) == 'D')
            {
              ++pCount;
              nExpandStrLen+=nFileDirLen;
              continue;
            }
            if (*(pCount + 1) == 'a' || *(pCount + 1) == 'A')
            {
              ++pCount;
              nExpandStrLen+=nExeDirLen;
              continue;
            }
            if (*(pCount + 1) == 'm' || *(pCount + 1) == 'M')
            {
              ++pCount;
              nExpandStrLen+=nToolbarIDLen;
              continue;
            }
            if (*(pCount + 1) == 'i' || *(pCount + 1) == 'I')
            {
              ++pCount;
              nExpandStrLen+=nItemIDLen;
              continue;
            }
          }
          else ++nExpandStrLen;
        }

        //Expand string
        if (lpParameter->pExpanded) GlobalFree((HGLOBAL)lpParameter->pExpanded);

        if (lpParameter->pExpanded=(unsigned char *)GlobalAlloc(GPTR, nExpandStrLen + 1))
        {
          pExpandStr=(char *)lpParameter->pExpanded;

          for (pCount=szString; *pCount; ++pCount)
          {
            if (*pCount == '%')
            {
              if (*(pCount + 1) == '%')
              {
                ++pCount;
                *pExpandStr++='%';
                continue;
              }
              if (*(pCount + 1) == 'f' || *(pCount + 1) == 'F')
              {
                ++pCount;
                lstrcpyA(pExpandStr, pFile);
                pExpandStr+=nFileLen;
                continue;
              }
              if (*(pCount + 1) == 'd' || *(pCount + 1) == 'D')
              {
                ++pCount;
                lstrcpyA(pExpandStr, szFileDir);
                pExpandStr+=nFileDirLen;
                continue;
              }
              if (*(pCount + 1) == 'a' || *(pCount + 1) == 'A')
              {
                ++pCount;
                lstrcpyA(pExpandStr, pExeDir);
                pExpandStr+=nExeDirLen;
                continue;
              }
              if (*(pCount + 1) == 'm' || *(pCount + 1) == 'M')
              {
                ++pCount;
                lstrcpyA(pExpandStr, pToolbarID);
                pExpandStr+=nToolbarIDLen;
                continue;
              }
              if (*(pCount + 1) == 'i' || *(pCount + 1) == 'I')
              {
                ++pCount;
                lstrcpyA(pExpandStr, pItemID);
                pExpandStr+=nItemIDLen;
                continue;
              }
            }
            else *pExpandStr++=*pCount;
          }
        }
        GlobalFree((HGLOBAL)szString);
      }
    }
    lpParameter=lpParameter->next;
  }
}

void SetParametersExpCharW(HSTACK *hParamStack, wchar_t *wpFile, wchar_t *wpExeDir, wchar_t *wpToolbarID, wchar_t *wpItemID)
{
  //%f -file, %d -file directory, %a -AkelPad directory, %% -%
  PARAMETER *lpParameter=(PARAMETER *)hParamStack->first;
  wchar_t wszFileDir[MAX_PATH];
  wchar_t *wszString;
  wchar_t *wpCount;
  wchar_t *wpExpandStr;
  int nFileLen;
  int nFileDirLen;
  int nExeDirLen;
  int nToolbarIDLen;
  int nItemIDLen;
  int nExpandStrLen;
  int nEnvironmentLen;

  nFileLen=lstrlenW(wpFile);
  nFileDirLen=GetFileDirW(wpFile, wszFileDir, MAX_PATH);
  nExeDirLen=lstrlenW(wpExeDir);
  nToolbarIDLen=lstrlenW(wpToolbarID);
  nItemIDLen=lstrlenW(wpItemID);
  nExpandStrLen=0;

  while (lpParameter)
  {
    if (lpParameter->dwType == PARAM_CHAR)
    {
      nEnvironmentLen=ExpandEnvironmentStringsW((wchar_t *)lpParameter->lParam, NULL, 0);

      if (wszString=(wchar_t *)GlobalAlloc(GPTR, nEnvironmentLen * sizeof(wchar_t)))
      {
        //Expand environment strings
        ExpandEnvironmentStringsW((wchar_t *)lpParameter->lParam, wszString, nEnvironmentLen);

        //Calculate expanded size
        for (wpCount=wszString; *wpCount; ++wpCount)
        {
          if (*wpCount == '%')
          {
            if (*(wpCount + 1) == '%')
            {
              ++wpCount;
              ++nExpandStrLen;
              continue;
            }
            if (*(wpCount + 1) == 'f' || *(wpCount + 1) == 'F')
            {
              ++wpCount;
              nExpandStrLen+=nFileLen;
              continue;
            }
            if (*(wpCount + 1) == 'd' || *(wpCount + 1) == 'D')
            {
              ++wpCount;
              nExpandStrLen+=nFileDirLen;
              continue;
            }
            if (*(wpCount + 1) == 'a' || *(wpCount + 1) == 'A')
            {
              ++wpCount;
              nExpandStrLen+=nExeDirLen;
              continue;
            }
            if (*(wpCount + 1) == 'm' || *(wpCount + 1) == 'M')
            {
              ++wpCount;
              nExpandStrLen+=nToolbarIDLen;
              continue;
            }
            if (*(wpCount + 1) == 'i' || *(wpCount + 1) == 'I')
            {
              ++wpCount;
              nExpandStrLen+=nItemIDLen;
              continue;
            }
          }
          else ++nExpandStrLen;
        }

        //Expand string
        if (lpParameter->pExpanded) GlobalFree((HGLOBAL)lpParameter->pExpanded);

        if (lpParameter->pExpanded=(unsigned char *)GlobalAlloc(GPTR, (nExpandStrLen + 1) * sizeof(wchar_t)))
        {
          wpExpandStr=(wchar_t *)lpParameter->pExpanded;

          for (wpCount=wszString; *wpCount; ++wpCount)
          {
            if (*wpCount == '%')
            {
              if (*(wpCount + 1) == '%')
              {
                ++wpCount;
                *wpExpandStr++='%';
                continue;
              }
              if (*(wpCount + 1) == 'f' || *(wpCount + 1) == 'F')
              {
                ++wpCount;
                lstrcpyW(wpExpandStr, wpFile);
                wpExpandStr+=nFileLen;
                continue;
              }
              if (*(wpCount + 1) == 'd' || *(wpCount + 1) == 'D')
              {
                ++wpCount;
                lstrcpyW(wpExpandStr, wszFileDir);
                wpExpandStr+=nFileDirLen;
                continue;
              }
              if (*(wpCount + 1) == 'a' || *(wpCount + 1) == 'A')
              {
                ++wpCount;
                lstrcpyW(wpExpandStr, wpExeDir);
                wpExpandStr+=nExeDirLen;
                continue;
              }
              if (*(wpCount + 1) == 'm' || *(wpCount + 1) == 'M')
              {
                ++wpCount;
                lstrcpyW(wpExpandStr, wpToolbarID);
                wpExpandStr+=nToolbarIDLen;
                continue;
              }
              if (*(wpCount + 1) == 'i' || *(wpCount + 1) == 'I')
              {
                ++wpCount;
                lstrcpyW(wpExpandStr, wpItemID);
                wpExpandStr+=nItemIDLen;
                continue;
              }
            }
            else *wpExpandStr++=*wpCount;
          }
        }
        GlobalFree((HGLOBAL)wszString);
      }
    }
    lpParameter=lpParameter->next;
  }
}

int CreateParametersStruct(HSTACK *hParamStack, unsigned char **lppStruct)
{
  PARAMETER *lpParameter=(PARAMETER *)hParamStack->first;
  unsigned char *lpStruct=NULL;
  int nStructSize=0;
  int nOffset=0;
  int nElements=0;
  int nIndex=0;

  if (nElements=StackSize((stack *)hParamStack->first, (stack *)hParamStack->last))
  {
    nStructSize=(nElements + 1) * sizeof(int);

    if (lpStruct=(unsigned char *)GlobalAlloc(GPTR, nStructSize))
    {
      while (lpParameter)
      {
        if (nIndex == 1)
        {
          //nIndex == 1 is the size of the call parameters structure
          *((int *)(lpStruct + nOffset))=nElements * sizeof(int);
          nOffset+=sizeof(int);
          ++nIndex;
        }

        //nIndex == 0 is function name, nIndex >= 2 is call parameters
        if (lpParameter->dwType == PARAM_CHAR)
          *((int *)(lpStruct + nOffset))=(int)lpParameter->pExpanded;
        else
          *((int *)(lpStruct + nOffset))=lpParameter->lParam;

        nOffset+=sizeof(int);
        ++nIndex;
        lpParameter=lpParameter->next;
      }
    }
  }
  *lppStruct=lpStruct;
  return nStructSize;
}

int GetParameterInt(HSTACK *hParamStack, int nIndex)
{
  PARAMETER *lpParameter;

  if (!StackGetElement((stack *)hParamStack->first, (stack *)hParamStack->last, (stack **)&lpParameter, nIndex))
  {
    if (lpParameter->dwType == PARAM_INT)
      return lpParameter->lParam;
  }
  return 0;
}

unsigned char* GetParameterChar(HSTACK *hParamStack, int nIndex)
{
  PARAMETER *lpParameter;

  if (!StackGetElement((stack *)hParamStack->first, (stack *)hParamStack->last, (stack **)&lpParameter, nIndex))
  {
    if (lpParameter->dwType == PARAM_CHAR)
      return (unsigned char *)lpParameter->lParam;
  }
  return NULL;
}

unsigned char* GetParameterExpChar(HSTACK *hParamStack, int nIndex)
{
  PARAMETER *lpParameter;

  if (!StackGetElement((stack *)hParamStack->first, (stack *)hParamStack->last, (stack **)&lpParameter, nIndex))
  {
    if (lpParameter->dwType == PARAM_CHAR)
      return lpParameter->pExpanded;
  }
  return NULL;
}

void FreeActionParameters(HSTACK *hParamStack)
{
  PARAMETER *lpParameter=(PARAMETER *)hParamStack->first;

  while (lpParameter)
  {
    if (lpParameter->dwType == PARAM_CHAR)
    {
      if (lpParameter->lParam) GlobalFree((HGLOBAL)lpParameter->lParam);
      if (lpParameter->pExpanded) GlobalFree((HGLOBAL)lpParameter->pExpanded);
    }
    lpParameter=lpParameter->next;
  }
  StackClear((stack **)&hParamStack->first, (stack **)&hParamStack->last);
}

void GetIconParametersA(char *pText, char *szIconFile, int nMaxIconFile, int *nIconIndex, char **ppText)
{
  char chStopChar;
  int i;

  szIconFile[0]='\0';
  *nIconIndex=0;

  //File
  while (*pText == ' ' || *pText == '\t') ++pText;

  if (*pText == '\"' || *pText == '\'' || *pText == '`')
  {
    chStopChar=*pText++;

    for (i=0; i < nMaxIconFile && *pText != chStopChar && *pText != '\0'; ++i, ++pText)
    {
      szIconFile[i]=*pText;
    }
    szIconFile[i]='\0';

    while (*pText != ',' && *pText != ')' && *pText != '\0')
      ++pText;
    if (*pText == ',')
      ++pText;
    else
      goto End;
  }

  //Index
  while (*pText == ' ' || *pText == '\t') ++pText;

  *nIconIndex=xatoiA(pText);

  while (*pText != ',' && *pText != ')' && *pText != '\0')
    ++pText;
  if (*pText == ',')
    ++pText;
  else
    goto End;

  //End
  End:
  if (*pText == ')')
    ++pText;
  *ppText=pText;
}

void GetIconParametersW(wchar_t *wpText, wchar_t *wszIconFile, int nMaxIconFile, int *nIconIndex, wchar_t **wppText)
{
  wchar_t wchStopChar;
  int i;

  wszIconFile[0]='\0';
  *nIconIndex=0;

  //File
  while (*wpText == ' ' || *wpText == '\t') ++wpText;

  if (*wpText == '\"' || *wpText == '\'' || *wpText == '`')
  {
    wchStopChar=*wpText++;

    for (i=0; i < nMaxIconFile && *wpText != wchStopChar && *wpText != '\0'; ++i, ++wpText)
    {
      wszIconFile[i]=*wpText;
    }
    wszIconFile[i]='\0';

    while (*wpText != ',' && *wpText != ')' && *wpText != '\0')
      ++wpText;
    if (*wpText == ',')
      ++wpText;
    else
      goto End;
  }

  //Index
  while (*wpText == ' ' || *wpText == '\t') ++wpText;

  *nIconIndex=xatoiW(wpText);

  while (*wpText != ',' && *wpText != ')' && *wpText != '\0')
    ++wpText;
  if (*wpText == ',')
    ++wpText;
  else
    goto End;

  //End
  End:
  if (*wpText == ')')
    ++wpText;
  *wppText=wpText;
}

int TranslateFileStringA(char *pString, char *szBuffer, int nBufferSize)
{
  //%a -AkelPad directory, %% -%
  char *pExeDir=szExeDir;
  char *szString;
  int nEnvironmentLen;
  int nExeDirLen;
  int a=0;
  int b=0;

  nExeDirLen=lstrlenA(pExeDir);
  nEnvironmentLen=ExpandEnvironmentStringsA(pString, NULL, 0);

  if (szString=(char *)GlobalAlloc(GPTR, nEnvironmentLen))
  {
    //Expand environment strings
    ExpandEnvironmentStringsA(pString, szString, nEnvironmentLen);
    pString=szString;

    for (; pString[a] && (!szBuffer || b < nBufferSize); ++a, ++b)
    {
      if (pString[a] == '%')
      {
        if (pString[++a] == '%')
        {
          if (szBuffer) szBuffer[b]='%';
        }
        else if (pString[a] == 'a' || pString[a] == 'A')
        {
          if (!szBuffer || b + nExeDirLen <= nBufferSize)
          {
            if (szBuffer) lstrcpyA(szBuffer + b, pExeDir);
            b+=nExeDirLen - 1;
          }
          else break;
        }
        else break;
      }
      else if (szBuffer) szBuffer[b]=pString[a];
    }
    GlobalFree((HGLOBAL)szString);
  }
  if (szBuffer && b < nBufferSize) szBuffer[b]='\0';
  return b;
}

int TranslateFileStringW(wchar_t *wpString, wchar_t *wszBuffer, int nBufferSize)
{
  //%a -AkelPad directory, %% -%
  wchar_t *wpExeDir=wszExeDir;
  wchar_t *wszString;
  int nEnvironmentLen;
  int nExeDirLen;
  int a=0;
  int b=0;

  nExeDirLen=lstrlenW(wpExeDir);
  nEnvironmentLen=ExpandEnvironmentStringsW(wpString, NULL, 0);

  if (wszString=(wchar_t *)GlobalAlloc(GPTR, nEnvironmentLen * sizeof(wchar_t)))
  {
    //Expand environment strings
    ExpandEnvironmentStringsW(wpString, wszString, nEnvironmentLen);
    wpString=wszString;

    for (; wpString[a] && (!wszBuffer || b < nBufferSize); ++a, ++b)
    {
      if (wpString[a] == '%')
      {
        if (wpString[++a] == '%')
        {
          if (wszBuffer) wszBuffer[b]='%';
        }
        else if (wpString[a] == 'a' || wpString[a] == 'A')
        {
          if (!wszBuffer || b + nExeDirLen <= nBufferSize)
          {
            if (wszBuffer) lstrcpyW(wszBuffer + b, wpExeDir);
            b+=nExeDirLen - 1;
          }
          else break;
        }
        else break;
      }
      else if (wszBuffer) wszBuffer[b]=wpString[a];
    }
    GlobalFree((HGLOBAL)wszString);
  }
  if (wszBuffer && b < nBufferSize) wszBuffer[b]='\0';
  return b;
}

int NextStringA(char *pText, char *szStr, int nStrLen, char **ppText, int *nMinus)
{
  int i;

  while (*pText == ' ' || *pText == '\t' || *pText == '\r') ++pText;

  if (*pText == '-')
  {
    if (nMinus) *nMinus=1;
    ++pText;
  }
  else
  {
    if (nMinus) *nMinus=0;
  }

  if (*pText == '\"')
  {
    ++pText;
    i=0;

    while (*pText != '\"' && *pText != '\0')
    {
      if (i < nStrLen) szStr[i++]=*pText;
      ++pText;
    }
  }
  else
  {
    i=0;

    while (*pText != ' ' && *pText != '\r' && *pText != '\0')
    {
      if (i < nStrLen) szStr[i++]=*pText;
      ++pText;
    }
  }
  szStr[i]='\0';
  if (*pText != '\r' && *pText != '\0') ++pText;
  if (ppText) *ppText=pText;
  return i;
}

int NextStringW(wchar_t *wpText, wchar_t *wszStr, int nStrLen, wchar_t **wppText, int *nMinus)
{
  int i;

  while (*wpText == ' ' || *wpText == '\t' || *wpText == '\r') ++wpText;

  if (*wpText == '-')
  {
    if (nMinus) *nMinus=1;
    ++wpText;
  }
  else
  {
    if (nMinus) *nMinus=0;
  }

  if (*wpText == '\"')
  {
    ++wpText;
    i=0;

    while (*wpText != '\"' && *wpText != '\0')
    {
      if (i < nStrLen) wszStr[i++]=*wpText;
      ++wpText;
    }
  }
  else
  {
    i=0;

    while (*wpText != ' ' && *wpText != '\r' && *wpText != '\0')
    {
      if (i < nStrLen) wszStr[i++]=*wpText;
      ++wpText;
    }
  }
  wszStr[i]='\0';
  if (*wpText != '\r' && *wpText != '\0') ++wpText;
  if (wppText) *wppText=wpText;
  return i;
}

int GetActionNameA(char *pText, char *szStr, int nStrLen, char **ppText)
{
  int i=0;

  while (*pText == '\"' || *pText == ' ' || *pText == '\t') ++pText;

  while (*pText != '(' && *pText != '\r' && *pText != '\0')
  {
    if (i < nStrLen) szStr[i++]=*pText;
    ++pText;
  }
  szStr[i]='\0';
  if (*pText != '\r' && *pText != '\0') ++pText;
  if (ppText) *ppText=pText;
  return i;
}

int GetActionNameW(wchar_t *wpText, wchar_t *wszStr, int nStrLen, wchar_t **wppText)
{
  int i=0;

  while (*wpText == '\"' || *wpText == ' ' || *wpText == '\t') ++wpText;

  while (*wpText != '(' && *wpText != '\r' && *wpText != '\0')
  {
    if (i < nStrLen) wszStr[i++]=*wpText;
    ++wpText;
  }
  wszStr[i]='\0';
  if (*wpText != '\r' && *wpText != '\0') ++wpText;
  if (wppText) *wppText=wpText;
  return i;
}

int GetFileDirA(char *pFile, char *szFileDir, int nFileDirLen)
{
  int i;

  if (!nFileDirLen) return 0;
  szFileDir[0]='\0';

  for (i=lstrlenA(pFile) - 1; i > 0; --i)
  {
    if (pFile[i] == '\\')
    {
      i=min(nFileDirLen, i + 1);
      lstrcpynA(szFileDir, pFile, i);
      return (i - 1);
    }
  }
  return 0;
}

int GetFileDirW(wchar_t *wpFile, wchar_t *wszFileDir, int nFileDirLen)
{
  int i;

  if (!nFileDirLen) return 0;
  wszFileDir[0]='\0';

  for (i=lstrlenW(wpFile) - 1; i > 0; --i)
  {
    if (wpFile[i] == '\\')
    {
      i=min(nFileDirLen, i + 1);
      lstrcpynW(wszFileDir, wpFile, i);
      return (i - 1);
    }
  }
  return 0;
}

void ShowStandartEditMenu(HWND hWnd, HMENU hMenu, BOOL bMouse)
{
  RECT rcRect;
  POINT pt;
  CHARRANGE cr;
  int nCmd;

  if (!bMouse)
  {
    GetWindowRect(hWnd, &rcRect);
    pt.x=rcRect.left;
    pt.y=rcRect.top;
  }
  else GetCursorPos(&pt);

  SendMessage(hWnd, EM_EXGETSEL, 0, (LPARAM)&cr);
  EnableMenuItem(hMenu, IDM_EDIT_UNDO, SendMessage(hWnd, EM_CANUNDO, 0, 0)?MF_ENABLED:MF_GRAYED);
  EnableMenuItem(hMenu, IDM_EDIT_REDO, SendMessage(hWnd, EM_CANREDO, 0, 0)?MF_ENABLED:MF_GRAYED);
  EnableMenuItem(hMenu, IDM_EDIT_PASTE, SendMessage(hWnd, EM_CANPASTE, 0, 0)?MF_ENABLED:MF_GRAYED);
  EnableMenuItem(hMenu, IDM_EDIT_CUT, (cr.cpMin < cr.cpMax)?MF_ENABLED:MF_GRAYED);
  EnableMenuItem(hMenu, IDM_EDIT_CLEAR, (cr.cpMin < cr.cpMax)?MF_ENABLED:MF_GRAYED);
  EnableMenuItem(hMenu, IDM_EDIT_COPY, (cr.cpMin < cr.cpMax)?MF_ENABLED:MF_GRAYED);

  nCmd=TrackPopupMenu(hMenu, TPM_RETURNCMD|TPM_NONOTIFY|TPM_LEFTBUTTON|TPM_RIGHTBUTTON, pt.x, pt.y, 0, hWnd, NULL);

  if (nCmd == IDM_EDIT_UNDO)
    SendMessage(hWnd, EM_UNDO, 0, 0);
  else if (nCmd == IDM_EDIT_REDO)
    SendMessage(hWnd, EM_REDO, 0, 0);
  else if (nCmd == IDM_EDIT_CUT)
    SendMessage(hWnd, WM_CUT, 0, 0);
  else if (nCmd == IDM_EDIT_COPY)
    SendMessage(hWnd, WM_COPY, 0, 0);
  else if (nCmd == IDM_EDIT_PASTE)
    SendMessage(hWnd, WM_PASTE, 0, 0);
  else if (nCmd == IDM_EDIT_CLEAR)
    SendMessage(hWnd, WM_CLEAR, 0, 0);
  else if (nCmd == IDM_EDIT_SELECTALL)
    SendMessage(hWnd, EM_SETSEL, 0, -1);
}

BOOL GetWindowPos(HWND hWnd, HWND hWndOwner, RECT *rc)
{
  if (GetWindowRect(hWnd, rc))
  {
    rc->right-=rc->left;
    rc->bottom-=rc->top;

    if (hWndOwner)
    {
      if (!ScreenToClient(hWndOwner, (POINT *)&rc->left))
        return FALSE;
    }
    return TRUE;
  }
  return FALSE;
}

BOOL DialogResizeMessages(DIALOGRESIZE *drs, RECT *rcInit, RECT *rcCurrent, HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  if (uMsg == WM_INITDIALOG)
  {
    RECT rcTemplate;

    GetWindowPos(hDlg, NULL, rcInit);
    rcTemplate=*rcCurrent;
    *rcCurrent=*rcInit;

    if (rcTemplate.right && rcTemplate.bottom)
    {
      rcTemplate.left=rcInit->left + (rcInit->right - rcTemplate.right) / 2;
      rcTemplate.top=rcInit->top + (rcInit->bottom - rcTemplate.bottom) / 2;
      SetWindowPos(hDlg, 0, rcTemplate.left, rcTemplate.top, rcTemplate.right, rcTemplate.bottom, SWP_NOZORDER);
    }
  }
  else if (uMsg == WM_GETMINMAXINFO)
  {
    MINMAXINFO *mmi=(MINMAXINFO *)lParam;

    mmi->ptMinTrackSize.x=rcInit->right;
    mmi->ptMinTrackSize.y=rcInit->bottom;
  }
  else if (uMsg == WM_SIZE)
  {
    if (lParam)
    {
      RECT rcTemplate;
      RECT rcControl;
      DWORD dwFlags;
      POINT pt;
      int i;

      GetWindowPos(hDlg, NULL, &rcTemplate);
      pt.x=rcTemplate.right - rcCurrent->right;
      pt.y=rcTemplate.bottom - rcCurrent->bottom;
      *rcCurrent=rcTemplate;

      for (i=0; drs[i].lpWnd; ++i)
      {
        if (*drs[i].lpWnd)
        {
          dwFlags=0;
          if (drs[i].dwType & DRS_SIZE)
            dwFlags|=SWP_NOMOVE;
          else if (drs[i].dwType & DRS_MOVE)
            dwFlags|=SWP_NOSIZE;
          GetWindowPos(*drs[i].lpWnd, hDlg, &rcControl);
          SetWindowPos(*drs[i].lpWnd, 0, rcControl.left + ((drs[i].dwType & DRS_X)?pt.x:0), rcControl.top + ((drs[i].dwType & DRS_Y)?pt.y:0), rcControl.right + ((drs[i].dwType & DRS_X)?pt.x:0), rcControl.bottom + ((drs[i].dwType & DRS_Y)?pt.y:0), dwFlags|SWP_NOZORDER);
        }
      }
      InvalidateRect(hDlg, NULL, TRUE);
      return TRUE;
    }
  }
  else if (uMsg == WM_PAINT)
  {
    PAINTSTRUCT ps;
    RECT rcGrip;
    HDC hDC;

    if (hDC=BeginPaint(hDlg, &ps))
    {
      GetClientRect(hDlg, &rcGrip);
      rcGrip.left=rcGrip.right - GetSystemMetrics(SM_CXVSCROLL);
      rcGrip.top=rcGrip.bottom - GetSystemMetrics(SM_CYVSCROLL);
      DrawFrameControl(hDC, &rcGrip, DFC_SCROLL, DFCS_SCROLLSIZEGRIP);
      EndPaint(hDlg, &ps);
    }
  }
  return FALSE;
}


//// Options

void ReadOptionsA()
{
  PLUGINOPTIONA po;
  HANDLE hOptions;
  DWORD dwSize;
  DWORD dwSize2;

  if (hOptions=(HANDLE)SendMessage(hMainWnd, AKD_BEGINOPTIONS, POB_READ, (LPARAM)szPluginName))
  {
    po.pOptionName="ToolBarText";
    po.dwType=PO_BINARY;
    po.lpData=NULL;
    po.dwData=0;
    dwSize=SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);

    if (dwSize)
    {
      if (wszToolBarText=(wchar_t *)GlobalAlloc(GPTR, dwSize))
      {
        po.pOptionName="ToolBarText";
        po.dwType=PO_BINARY;
        po.lpData=(LPBYTE)wszToolBarText;
        po.dwData=dwSize;
        SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);
      }
    }

    po.pOptionName="BigIcons";
    po.dwType=PO_DWORD;
    po.lpData=(LPBYTE)&bBigIcons;
    po.dwData=sizeof(DWORD);
    SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);

    po.pOptionName="FlatButtons";
    po.dwType=PO_DWORD;
    po.lpData=(LPBYTE)&bFlatButtons;
    po.dwData=sizeof(DWORD);
    SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);

    po.pOptionName="WindowRect";
    po.dwType=PO_BINARY;
    po.lpData=(LPBYTE)&rcMainCurrentDialog;
    po.dwData=sizeof(RECT);
    SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);

    SendMessage(hMainWnd, AKD_ENDOPTIONS, (WPARAM)hOptions, 0);
  }

  if (!wszToolBarText)
  {
    dwSize=wcslen(TXT_DEFAULT_PART1W) * sizeof(wchar_t);
    dwSize2=wcslen(TXT_DEFAULT_PART2W) * sizeof(wchar_t) + 2;

    if (wszToolBarText=(wchar_t *)GlobalAlloc(GPTR, dwSize + dwSize2))
    {
      memcpy((unsigned char *)wszToolBarText, TXT_DEFAULT_PART1W, dwSize);
      memcpy((unsigned char *)wszToolBarText + dwSize, TXT_DEFAULT_PART2W, dwSize2);
    }
  }

  //Convert Unicode to Ansi
  if (wszToolBarText)
  {
    dwSize=WideCharToMultiByte(CP_ACP, 0, wszToolBarText, -1, NULL, 0, NULL, NULL);

    if (szToolBarText=(char *)GlobalAlloc(GPTR, dwSize))
    {
      WideCharToMultiByte(CP_ACP, 0, wszToolBarText, -1, szToolBarText, dwSize, NULL, NULL);
    }
    GlobalFree((HGLOBAL)wszToolBarText);
    wszToolBarText=NULL;
  }
}

void ReadOptionsW()
{
  PLUGINOPTIONW po;
  HANDLE hOptions;
  DWORD dwSize;
  DWORD dwSize2;

  if (hOptions=(HANDLE)SendMessage(hMainWnd, AKD_BEGINOPTIONS, POB_READ, (LPARAM)wszPluginName))
  {
    po.pOptionName=L"ToolBarText";
    po.dwType=PO_BINARY;
    po.lpData=NULL;
    po.dwData=0;
    dwSize=SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);

    if (dwSize)
    {
      if (wszToolBarText=(wchar_t *)GlobalAlloc(GPTR, dwSize))
      {
        po.pOptionName=L"ToolBarText";
        po.dwType=PO_BINARY;
        po.lpData=(LPBYTE)wszToolBarText;
        po.dwData=dwSize;
        SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);
      }
    }

    po.pOptionName=L"BigIcons";
    po.dwType=PO_DWORD;
    po.lpData=(LPBYTE)&bBigIcons;
    po.dwData=sizeof(DWORD);
    SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);

    po.pOptionName=L"FlatButtons";
    po.dwType=PO_DWORD;
    po.lpData=(LPBYTE)&bFlatButtons;
    po.dwData=sizeof(DWORD);
    SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);

    po.pOptionName=L"WindowRect";
    po.dwType=PO_BINARY;
    po.lpData=(LPBYTE)&rcMainCurrentDialog;
    po.dwData=sizeof(RECT);
    SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);

    SendMessage(hMainWnd, AKD_ENDOPTIONS, (WPARAM)hOptions, 0);
  }

  if (!wszToolBarText)
  {
    dwSize=wcslen(TXT_DEFAULT_PART1W) * sizeof(wchar_t);
    dwSize2=wcslen(TXT_DEFAULT_PART2W) * sizeof(wchar_t) + 2;

    if (wszToolBarText=(wchar_t *)GlobalAlloc(GPTR, dwSize + dwSize2))
    {
      memcpy((unsigned char *)wszToolBarText, TXT_DEFAULT_PART1W, dwSize);
      memcpy((unsigned char *)wszToolBarText + dwSize, TXT_DEFAULT_PART2W, dwSize2);
    }
  }
}

void SaveOptionsA(DWORD dwFlags)
{
  PLUGINOPTIONA po;
  HANDLE hOptions;
  DWORD dwSize;

  if (hOptions=(HANDLE)SendMessage(hMainWnd, AKD_BEGINOPTIONS, POB_SAVE, (LPARAM)szPluginName))
  {
    if (dwFlags & OF_TOOLBARTEXT)
    {
      if (szToolBarText)
      {
        dwSize=MultiByteToWideChar(CP_ACP, 0, szToolBarText, -1, NULL, 0) * sizeof(wchar_t);

        if (wszToolBarText=(wchar_t *)GlobalAlloc(GPTR, dwSize))
        {
          MultiByteToWideChar(CP_ACP, 0, szToolBarText, -1, wszToolBarText, dwSize / sizeof(wchar_t));

          po.pOptionName="ToolBarText";
          po.dwType=PO_BINARY;
          po.lpData=(LPBYTE)wszToolBarText;
          po.dwData=wcslen(wszToolBarText) * sizeof(wchar_t) + 2;
          SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);

          GlobalFree((HGLOBAL)wszToolBarText);
          wszToolBarText=NULL;
        }
      }

      po.pOptionName="BigIcons";
      po.dwType=PO_DWORD;
      po.lpData=(LPBYTE)&bBigIcons;
      po.dwData=sizeof(DWORD);
      SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);

      po.pOptionName="FlatButtons";
      po.dwType=PO_DWORD;
      po.lpData=(LPBYTE)&bFlatButtons;
      po.dwData=sizeof(DWORD);
      SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);
    }

    if (dwFlags & OF_WINDOWRECT)
    {
      po.pOptionName="WindowRect";
      po.dwType=PO_BINARY;
      po.lpData=(LPBYTE)&rcMainCurrentDialog;
      po.dwData=sizeof(RECT);
      SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);
    }
    SendMessage(hMainWnd, AKD_ENDOPTIONS, (WPARAM)hOptions, 0);
  }
}

void SaveOptionsW(DWORD dwFlags)
{
  PLUGINOPTIONW po;
  HANDLE hOptions;

  if (hOptions=(HANDLE)SendMessage(hMainWnd, AKD_BEGINOPTIONS, POB_SAVE, (LPARAM)wszPluginName))
  {
    if (dwFlags & OF_TOOLBARTEXT)
    {
      po.pOptionName=L"ToolBarText";
      po.dwType=PO_BINARY;
      po.lpData=(LPBYTE)wszToolBarText;
      po.dwData=wcslen(wszToolBarText) * sizeof(wchar_t) + 2;
      SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);

      po.pOptionName=L"BigIcons";
      po.dwType=PO_DWORD;
      po.lpData=(LPBYTE)&bBigIcons;
      po.dwData=sizeof(DWORD);
      SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);

      po.pOptionName=L"FlatButtons";
      po.dwType=PO_DWORD;
      po.lpData=(LPBYTE)&bFlatButtons;
      po.dwData=sizeof(DWORD);
      SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);
    }

    if (dwFlags & OF_WINDOWRECT)
    {
      po.pOptionName=L"WindowRect";
      po.dwType=PO_BINARY;
      po.lpData=(LPBYTE)&rcMainCurrentDialog;
      po.dwData=sizeof(RECT);
      SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);
    }

    SendMessage(hMainWnd, AKD_ENDOPTIONS, (WPARAM)hOptions, 0);
  }
}

char* GetLangStringA(LANGID wLangID, int nStringID)
{
  static char szStringBuf[MAX_PATH];

  WideCharToMultiByte(CP_ACP, 0, GetLangStringW(wLangID, nStringID), -1, szStringBuf, MAX_PATH, NULL, NULL);
  return szStringBuf;
}

wchar_t* GetLangStringW(LANGID wLangID, int nStringID)
{
  if (wLangID == LANG_RUSSIAN)
  {
    if (nStringID == STRID_SETUP)
      return L"\x041D\x0430\x0441\x0442\x0440\x043E\x0438\x0442\x044C\x002E\x002E\x002E";
    if (nStringID == STRID_AUTOLOAD)
      return L"\x0022\x0025\x0073\x0022\x0020\x043D\x0435\x0020\x043F\x043E\x0434\x0434\x0435\x0440\x0436\x0438\x0432\x0430\x0435\x0442\x0020\x0430\x0432\x0442\x043E\x0437\x0430\x0433\x0440\x0443\x0437\x043A\x0443\x0020\x0028\x0022\x002B\x0022\x0020\x043F\x0435\x0440\x0435\x0434\x0020\x0022\x0043\x0061\x006C\x006C\x0022\x0029\x002E";
    if (nStringID == STRID_BIGICONS)
      return L"\x0411\x043E\x043B\x044C\x0448\x0438\x0435\x0020\x0438\x043A\x043E\x043D\x043A\x0438";
    if (nStringID == STRID_FLATBUTTONS)
      return L"\x041F\x043B\x043E\x0441\x043A\x0438\x0435\x0020\x043A\x043D\x043E\x043F\x043A\x0438";
    if (nStringID == STRID_OK)
      return L"\x004F\x004B";
    if (nStringID == STRID_CANCEL)
      return L"\x041E\x0442\x043C\x0435\x043D\x0430";
  }
  else
  {
    if (nStringID == STRID_SETUP)
      return L"Customize...";
    if (nStringID == STRID_AUTOLOAD)
      return L"\"%s\" doesn't support autoload (\"+\" before \"Call\").";
    if (nStringID == STRID_BIGICONS)
      return L"Big icons";
    if (nStringID == STRID_FLATBUTTONS)
      return L"Flat buttons";
    if (nStringID == STRID_OK)
      return L"OK";
    if (nStringID == STRID_CANCEL)
      return L"Cancel";
  }
  return L"";
}

void InitCommon(PLUGINDATA *pd)
{
  bInitCommon=TRUE;
  hInstanceDLL=pd->hInstanceDLL;
  hInstanceEXE=pd->hInstanceEXE;
  hMainWnd=pd->hMainWnd;
  hMdiClient=pd->hMdiClient;
  hMainMenu=pd->hMainMenu;
  hMenuRecentFiles=pd->hMenuRecentFiles;
  hMainIcon=pd->hMainIcon;
  bOldWindows=pd->bOldWindows;
  bMDI=pd->bMDI;
  bAkelEdit=pd->bAkelEdit;
  wLangSystem=PRIMARYLANGID(pd->wLangSystem);
  hPopupEdit=GetSubMenu(pd->hPopupMenu, 0);

  if (bOldWindows)
  {
    int i;

    for (i=0; ((char *)pd->pFunction)[i] != ':'; ++i)
      szPluginName[i]=((char *)pd->pFunction)[i];
    szPluginName[i]='\0';
  }
  else
  {
    int i;

    for (i=0; ((wchar_t *)pd->pFunction)[i] != ':'; ++i)
      wszPluginName[i]=((wchar_t *)pd->pFunction)[i];
    wszPluginName[i]='\0';
  }

  if (bOldWindows)
  {
    HMODULE hShell32;

    hShell32=GetModuleHandleA("shell32.dll");
    ExtractIconExAPtr=(UINT (WINAPI *)(char *, int, HICON *, HICON *, UINT))GetProcAddress(hShell32, "ExtractIconExA");

    lstrcpynA(szExeDir, (char *)pd->pAkelDir, MAX_PATH);
    ReadOptionsA();
  }
  else
  {
    HMODULE hShell32;

    hShell32=GetModuleHandleW(L"shell32.dll");
    ExtractIconExWPtr=(UINT (WINAPI *)(wchar_t *, int, HICON *, HICON *, UINT))GetProcAddress(hShell32, "ExtractIconExW");

    lstrcpynW(wszExeDir, (wchar_t *)pd->pAkelDir, MAX_PATH);
    ReadOptionsW();
  }
}

void InitMain()
{
  bInitMain=TRUE;

  //SubClass
  NewMainProcData=NULL;
  SendMessage(hMainWnd, AKD_SETMAINPROC, (WPARAM)NewMainProc, (LPARAM)&NewMainProcData);

  NewMainProcRetData=NULL;
  SendMessage(hMainWnd, AKD_SETMAINPROCRET, (WPARAM)NewMainProcRet, (LPARAM)&NewMainProcRetData);

  if (bMDI)
  {
    NewFrameProcRetData=NULL;
    SendMessage(hMainWnd, AKD_SETFRAMEPROCRET, (WPARAM)NewMainProcRet, (LPARAM)&NewFrameProcRetData);
  }
}

void UninitMain()
{
  bInitMain=FALSE;

  //Remove subclass
  if (NewMainProcData)
  {
    SendMessage(hMainWnd, AKD_SETMAINPROC, (WPARAM)NULL, (LPARAM)&NewMainProcData);
    NewMainProcData=NULL;
  }
  if (NewMainProcRetData)
  {
    SendMessage(hMainWnd, AKD_SETMAINPROCRET, (WPARAM)NULL, (LPARAM)&NewMainProcRetData);
    NewMainProcRetData=NULL;
  }
  if (bMDI)
  {
    if (NewFrameProcRetData)
    {
      SendMessage(hMainWnd, AKD_SETFRAMEPROCRET, (WPARAM)NULL, (LPARAM)&NewFrameProcRetData);
      NewFrameProcRetData=NULL;
    }
  }

  //Destroy toolbar
  if (bOldWindows)
  {
    if (bMainDialogRectSave) SaveOptionsA(OF_WINDOWRECT);
    DestroyToolbarA();
  }
  else
  {
    if (bMainDialogRectSave) SaveOptionsW(OF_WINDOWRECT);
    DestroyToolbarW();
  }
}

//Entry point
extern "C" BOOL WINAPI DllMain(HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved)
{
  if (fdwReason == DLL_PROCESS_ATTACH)
  {
  }
  else if (fdwReason == DLL_THREAD_ATTACH)
  {
  }
  else if (fdwReason == DLL_THREAD_DETACH)
  {
  }
  else if (fdwReason == DLL_PROCESS_DETACH)
  {
    if (bInitMain) UninitMain();
  }
  return TRUE;
}
